import Map from 'ol/Map.js';
import GoogleLayer from 'olgm/layer/Google.js';
import { defaults } from 'olgm/interaction.js';
import OLGoogleMaps from 'olgm/OLGoogleMaps.js';
import { View, Feature } from 'ol';
import Overlay from 'ol/Overlay';
import { fromLonLat, toLonLat, transformExtent } from 'ol/proj';
import TileLayer from 'ol/layer/Tile';
import OSM from 'ol/source/OSM';
import { Point, Circle, LineString, MultiPoint, MultiLineString, MultiPolygon } from 'ol/geom';
import { RegularShape, Style, Fill, Stroke, Text, Icon } from 'ol/style';
import { Vector, Cluster, TileWMS } from 'ol/source';
import { Vector as Vector$1, Heatmap } from 'ol/layer';
import { Draw, DoubleClickZoom } from 'ol/interaction';
import { addCommon } from 'ol/proj.js';
import AnimatedCluster from 'ol-ext/layer/AnimatedCluster';
import SelectCluster from 'ol-ext/interaction/selectCluster';
import Polygon, { fromCircle, fromExtent } from 'ol/geom/Polygon';
import { createEmpty, extend, containsExtent } from 'ol/extent';
import { defaults as defaults$1, FullScreen } from 'ol/control';
import swal from 'sweetalert2';
import IconAnchorUnits from 'ol/style/IconAnchorUnits';
import { Subject, config } from 'rxjs';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';
import CircleStyle from 'ol/style/Circle';
import LinearRing from 'ol/geom/LinearRing';
import { io, operation } from 'jsts/dist/jsts';
import WKT from 'ol/format/WKT';
import WFS from 'ol/format/WFS';
import { bbox } from 'ol/loadingstrategy';
import GML2 from 'ol/format/GML2';
import { FormsModule } from '@angular/forms';
import { NgxSpinnerService, NgxSpinnerModule } from 'ngx-spinner';
import { ColorPickerModule } from 'ngx-color-picker';
import { Filter, FiltersModule } from 'ngbi-filters';
import { Injectable, Component, ViewEncapsulation, NgModule, Input, ElementRef, ViewChild, Renderer2, HostListener, Output, EventEmitter, defineInjectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpClientModule } from '@angular/common/http';
import { NgbModal, NgbDropdownConfig, NgbDateParserFormatter, NgbCalendar, NgbActiveModal, NgbModule, NgbPaginationModule, NgbAlertModule } from '@ng-bootstrap/ng-bootstrap';
import { BrowserModule } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngbi-map.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgbiMapService {
    constructor() { }
}
NgbiMapService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgbiMapService.ctorParameters = () => [];
/** @nocollapse */ NgbiMapService.ngInjectableDef = defineInjectable({ factory: function NgbiMapService_Factory() { return new NgbiMapService(); }, token: NgbiMapService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngbi-map.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgbiMapComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
NgbiMapComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngbi-ngbi-map',
                template: `
    <p>
      ngbi-map works!
    </p>
  `
            }] }
];
/** @nocollapse */
NgbiMapComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mapa/mapa.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MapaComponent {
    /**
     * @param {?} modalService
     * @param {?} http
     * @param {?} spinner
     * @param {?} calendar
     * @param {?} config
     * @param {?} element
     * @param {?} renderer
     * @param {?} _parserFormatter
     */
    constructor(modalService, http, spinner, calendar, config$$1, element, renderer, _parserFormatter) {
        this.modalService = modalService;
        this.http = http;
        this.spinner = spinner;
        this.calendar = calendar;
        this.renderer = renderer;
        this._parserFormatter = _parserFormatter;
        this.clicExterno = new EventEmitter();
        this.utilizandoPopUp = false;
        // PARAMETROS DE BUSQUEDA
        this.texto = "";
        this.coordenadasActual = [];
        this.totalEncontrados = 0;
        // OTROS
        this.tipoSeleccionado = 'Polygon';
        this.Intersecciones = [];
        this.modoInterseccion = false;
        this.modoDiferencia = false;
        this.modoInterseccionAutomatica = false;
        this.tipoCirculo = 0;
        this.habilitarDireccion = true;
        this.hole = {};
        this.center = [];
        this.color = 'rgba(0,0,255,1)';
        this.zoom = 2;
        this.mapaPredeterminado = '';
        this.capasActuales = [];
        this.procesandoFeature = false;
        this.filtrosGlobales = [];
        this.showOption = false;
        this.busquedasTexto = [];
        this.teclaPresionada = "";
        this.featuresSeleccionados = [];
        this.inputPlaceholder = "Direcciones";
        this.viewChanged = new Subject();
        this.isCollapsed = true;
        this.isCollapsedR = true;
        this.figurasActivas = [];
        this.tiposOrigenes = []; //String concatenado.
        //String concatenado.
        this.busquedasActuales2 = [];
        this.busquedaTextuales = [];
        this.paginacionGeo = {
            pagActual: 1,
            RPP: 10,
            geometrysWKT: null,
            tipoOrigen: null,
            UUID: null
        };
        //La informacion que se mostraria en el detalle
        this.infoDetalle = [];
        this.infoVista = [];
        //Las keys array de array
        this.infoDetTitulo = [];
        //Los valores array de array
        this.infoDetValues = [];
        this.busquedaAnterior = [];
        this.chkActualizarResult = false;
        this.infoTitulos = [];
        this.infoDetBotones = [];
    }
    /**
     * @param {?} event
     * @return {?}
     */
    handleKeyboardDownEvent(event) {
        this.teclaPresionada = event.key;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    handleKeyboardUpEvent(event) {
        if (this.teclaPresionada == event.key && event.key == "Control") {
            this.teclaPresionada = null;
            this.featuresSeleccionados = [];
        }
        // console.log(event.key);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.obtenerConfiguracion().subscribe((/**
         * @param {?} response
         * @return {?}
         */
        (response) => {
            console.log("Configuraciones Api>>>>", response);
            try {
                this.confBusquedaGeo = response.modBusqueda;
            }
            catch (_a) {
                console.log("Error", `No se encontro configuracion Busqueda Geo!!!`);
            }
            try {
                this.confBusquedaText = response.modBusquedaTextuales;
            }
            catch (_b) {
                console.log("Error", `No se encontro configuracion busqueda textual!!!`);
            }
            try {
                this.confInicializacion = response.inicializacion;
            }
            catch (_c) {
                console.log("Error", `No se encontro configuracion de Inicializacion!!!`);
            }
            try {
                this.confCapas = response.capas.Property1;
            }
            catch (_d) {
                console.log("Error", `No se encontro configuracion de capas!!!`);
            }
            this.confResultadosVista = response.modResultadosVista;
            // {
            //   "Chat":{Vista:["NombreAlerta", "FechaCreacion", "Tipo", "Mensaje"],CampoEspeciales:{JSON:['Modelo'],fecha:["FechaCreacion"]},botones:[{class:"btn btn-primary",contenido:"prueba",accion:"accion_de_prueba"}]},
            //   "Bts":{Vista:["radio","mcc","net","area","cell","unit","range","samples","changeable","created","updated"]},
            //   "Nacional":{Vista:["N_Completo","NOM_EDO","CALLE","COLONIA","CP","OCUPACION"]}
            // }
            this.confBusquedaGeo.busquedas.forEach((/**
             * @param {?} busqueda
             * @return {?}
             */
            busqueda => {
                this.busquedasActuales2.push(busqueda);
                if (busqueda.visible == true) {
                    //reajuste
                    busqueda.visible = false;
                    this.cambiarStatusBusqueda(busqueda.titulo);
                    // this.tiposOrigenes.push(busqueda.nombre);
                }
            }));
            // {nombre:config.titulo,URL:config.busquedaTexto.URL
            // ,icon:config.busquedaTexto.icon,type:config.busquedaTexto.type,
            //   typeRequest:config.busquedaTexto.typeRequest,typeResponse:config.busquedaTexto.typeResponse,placeholder:config.busquedaTexto.placeholder};
            this.busquedasTexto.push({
                titulo: "Google", nombre: "Google maps",
                icon: "https://www.google.com/maps/about/images/home/home-maps-icon.svg?mmfb=de7ec406c933d20ac2caf9114c2434a9",
                placeholder: "direcciones"
            });
            this.confBusquedaText.busquedaTextuales.forEach((/**
             * @param {?} busqueda
             * @return {?}
             */
            (busqueda) => {
                this.busquedasTexto.push(busqueda);
            }));
            this.inicializarVariables();
            this.inicializarMapa();
            this.inicializarEventos();
            this.crearLayersBusqueda();
            if (this.filtroInicial) {
                this.busquedaInicial();
            }
            this.viewSubcription = this.viewChanged.pipe(distinctUntilChanged(), debounceTime(300)).subscribe((/**
             * @return {?}
             */
            () => {
                console.log(this.chkActualizarResult);
                if (this.buscando) {
                    if (this.chkActualizarResult) {
                        this.buscarArea.nativeElement.style.display = `none`;
                        if (this.source.getFeatures().length == 0) {
                            this.figurasActivas = [];
                            this.generarFiguraVentana();
                        }
                        else {
                            /** @type {?} */
                            let contieneFeature = false;
                            this.source.getFeatures().forEach((/**
                             * @param {?} feature
                             * @return {?}
                             */
                            feature => {
                                /** @type {?} */
                                let ext1 = this.map.getView().calculateExtent(this.map.getSize());
                                /** @type {?} */
                                let ext2 = feature.getGeometry().getExtent();
                                if (containsExtent(ext1, ext2))
                                    contieneFeature = true;
                            }));
                            //Si no contiene el feature en la vista
                            if (contieneFeature == false) {
                                this.figurasActivas = [];
                                this.generarFiguraVentana();
                            }
                        }
                        //if() layer de dibujos tiene dijos?
                        this.consultarV2();
                    }
                    else {
                        this.buscarArea.nativeElement.style.display = `block`;
                        this.labelActualizar.nativeElement.style.display = "block";
                        //activar boton
                    }
                }
            }));
        }));
        //this.habilitarDireccion=false;
    }
    /**
     * @return {?}
     */
    generarFiguraVentana() {
        /** @type {?} */
        let extent = this.map.getView().calculateExtent(this.map.getSize());
        /** @type {?} */
        let extGeometry = fromExtent(extent);
        /** @type {?} */
        let coords = extGeometry.getCoordinates();
        coords = coords[0];
        /** @type {?} */
        let coordsLatLon = [];
        coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[0]);
        coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[1]);
        coordsLatLon.push(toLonLat([coords[1][0], coords[1][1]])[0]);
        coordsLatLon.push(toLonLat([coords[1][0], coords[1][1]])[1]);
        coordsLatLon.push(toLonLat([coords[2][0], coords[2][1]])[0]);
        coordsLatLon.push(toLonLat([coords[2][0], coords[2][1]])[1]);
        coordsLatLon.push(toLonLat([coords[3][0], coords[3][1]])[0]);
        coordsLatLon.push(toLonLat([coords[3][0], coords[3][1]])[1]);
        coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[0]);
        coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[1]);
        console.log(coordsLatLon);
        this.busquedaGeo(coordsLatLon, 'Polygon', 5, extent);
    }
    /**
     * @return {?}
     */
    inicializarVariables() {
        this.infoBusquedas = [];
        this.busquedasActuales = [];
        this.content = document.getElementById('popup-content');
        this.container = document.getElementById('popup');
        this.closer = document.getElementById('popup-closer');
        console.log("CONFIGURACION INICIAL >>>", this.confInicializacion);
        if (this.confInicializacion) {
            this.center = fromLonLat(this.confInicializacion.center);
            this.color = this.confInicializacion.drawColor;
            this.zoom = this.confInicializacion.zoom;
            this.mapaPredeterminado = this.confInicializacion.mapaPredeterminado;
        }
        // this.confBusquedaGeo.busquedas.forEach(busqueda => {
        //   this.busquedasActuales2.push(busqueda);
        // });
    }
    /**
     * @return {?}
     */
    inicializarMapa() {
        addCommon();
        this.overlay = new Overlay({
            element: this.container,
            autoPan: true,
            autoPanAnimation: {
                duration: 250
            }
        });
        /** @type {?} */
        let center = this.center;
        // this.googleLayer.setVisible(true);
        this.OSMLayer = new TileLayer({
            source: new OSM,
            zIndex: 0
        });
        this.source = new Vector();
        /** @type {?} */
        let vector = new Vector$1({
            source: this.source,
            opacity: 0.5,
            zIndex: 0,
        });
        try {
            this.googleLayer = new GoogleLayer();
            /** @type {?} */
            let strokeProp = new Stroke({ color: 'black', width: 2 });
            /** @type {?} */
            let goldFill = new Fill({ color: 'blue' });
            /** @type {?} */
            let styleCache = {};
            /** @type {?} */
            let selectStyle = {};
            this.googleLayer.style = (/**
             * @param {?} feature
             * @return {?}
             */
            function (feature) {
                if (feature.get('features').length > 1) {
                    /** @type {?} */
                    let size;
                    if (!feature || feature.get('features') === undefined) {
                        size = 0;
                    }
                    else {
                        size = feature.get('features').length;
                    }
                    /** @type {?} */
                    let style = styleCache[size];
                    if (!style) {
                        style = new Style({
                            image: new RegularShape({
                                fill: goldFill,
                                stroke: strokeProp,
                                points: 4,
                                radius: 10,
                                angle: Math.PI / 4
                            }),
                            text: new Text({
                                text: size.toString(),
                                fill: new Fill({
                                    color: '#fff'
                                })
                            })
                        });
                        styleCache[size] = style;
                    }
                    return style;
                }
                else {
                    /** @type {?} */
                    let feat = feature.get('features');
                    /** @type {?} */
                    let src = feat[0].getStyle().getImage().getSrc();
                    /** @type {?} */
                    let style = feat[0].getStyle();
                    if (!selectStyle[src]) {
                        selectStyle[src] = style;
                    }
                    return selectStyle[src];
                }
            });
        }
        catch (_a) {
            console.log("Error googleLayer", "Hubo problemas con la capa de google maps y no se cargará...");
        }
        this.view = new View({
            center,
            zoom: this.zoom,
            maxZoom: 20,
            minZoom: 4
        });
        this.map = new Map({
            controls: defaults$1().extend([
                new FullScreen()
            ]),
            interactions: defaults(),
            layers: [
                this.OSMLayer, this.googleLayer, vector
            ],
            overlays: [this.overlay],
            target: 'map',
            view: this.view,
        });
        // sync(this.map);
        this.olGM = new OLGoogleMaps({ map: this.map, watch: {
                'vector': false
            } });
        this.olGM.activate();
        if (this.mapaPredeterminado == "OSM") {
            this.googleLayer.setVisible(false);
            this.OSMLayer.setVisible(true);
        }
        else if (this.mapaPredeterminado == "GoogleMaps") {
            this.googleLayer.setVisible(true);
            this.OSMLayer.setVisible(false);
        }
        if (this.confCapas) {
            this.confCapas.forEach((/**
             * @param {?} configCapa
             * @return {?}
             */
            configCapa => {
                /*
                        "nombre":"CDMA",
                        "URL":"http://127.0.0.1/cgi-bin/mapserv.exe?MAP=/ms4w/apps/bts/btsMap.map&service=WFS&version=1.0.0&request=GetFeature&typename=btsCDMA&outputFormat=gml3&maxFeatures=5000&bbox=",
                        "tipoEntrada":"WKT",
                        "tipoSalida":"ClusterAnimated",
                        "bbox":true,
                        "minZoom":15,
                        "stylePrefab":1,
                        "visible":false
                        */
                /** @type {?} */
                let newLayer = this.generarLayer(configCapa, this.generarSource(configCapa));
                console.log("LayerCreadoCapa", newLayer);
                this.map.addLayer(newLayer);
                this.capasActuales.push({ "nombre": configCapa.nombre, "layer": newLayer, config: config });
                if (configCapa.busquedaTexto) {
                    this.busquedasTexto.push({ nombre: configCapa.nombre, URL: configCapa.busquedaTexto.URL, icon: configCapa.busquedaTexto.icon, type: configCapa.busquedaTexto.type,
                        typeRequest: configCapa.busquedaTexto.typeRequest, typeResponse: configCapa.busquedaTexto.typeResponse, placeholder: configCapa.busquedaTexto.placeholder });
                }
                // this.generarLayerCluster(this.generarSourceCluster(configCapa.url));
            }));
        }
        /** @type {?} */
        let radiusDinamyc = 60 - (this.view.getZoom() * 2.8);
        this.mapaCalor = new Heatmap({
            source: new Vector(),
            weight: (/**
             * @param {?} feature
             * @return {?}
             */
            (feature) => {
                /** @type {?} */
                let total = parseInt(feature.get('total'));
                /** @type {?} */
                let weight = total > 25 ? 1 : total > 8 ? 0.7 : 0.4;
                return weight;
            }),
            // gradient: [
            //        'hsl(240, 100%, 50%)',
            //        'hsl(180, 100%, 50%)',
            //        'hsl(120, 100%, 50%)',
            //        'hsl(60, 100%, 50%)'
            // ],
            radius: radiusDinamyc,
            blur: 22,
            opacity: 0.80
        });
        this.mapaCalor.setZIndex(5000);
        this.map.addLayer(this.mapaCalor);
    }
    /**
     * @return {?}
     */
    inicializarEventos() {
        this.cerrarPopup(this.closer, this.selectedFeatures, this.overlay, this);
        // let dragBox = new DragBox({
        //   condition: platformModifierKeyOnly,
        //   onBoxEnd: ()=>{
        //     let coords = dragBox.getGeometry().getFlatCoordinates();
        //     this.busquedaGeo(coords,'Rectangle',5,dragBox.getGeometry().getExtent());
        //   }
        // });
        // let select = new Select({
        // style: this.arregloCapas[0].cluster.getStyle()
        // });
        // this.selectedFeatures = select.getFeatures(); 
        // console.log(select);
        // this.map.addInteraction(select);
        // this.desactivarZoomDobleClick(this.map);
        // this.eventDoubleClick(this.map,this.selectedFeatures);  
        this.selectCluster = new SelectCluster({
        // style: (features)=>{
        //   if(features.get('feature').length===1){
        //     let feature = features.get('feature')[0];
        //     return feature.getStyle();
        //   } 
        // }
        });
        this.selectedFeatures = this.selectCluster.getFeatures();
        this.selectedOn(this.selectedFeatures, this);
        this.map.addInteraction(this.selectCluster);
        // this.map.addInteraction(dragBox);
        // this.cambiarMapaCalor(false); ACTIVAR
        // this.ModificacionTamañoFeature(modifyS,this)
        // let modifyS = new Modify({source: this.source});
        // this.map.addInteraction(modifyS);
        this.eventoClick(this.map, this, this.content, this.overlay);
        this.InitBusquedaGM(true, this.direccionesElement.nativeElement, this.map);
        // this.filtrosGlobales = [];
        // this.confBusquedaGeo.filtros.forEach(filtro => {
        //   busqueda.filtros.forEach(filtro => {
        //     let obj:Filter = new Filter();
        //     obj.name=filtro.nombre;
        //     obj.title=filtro.titulo;
        //     obj.type=filtro.tipo;//date, text, select
        //     obj.valueFormat=filtro.valordefault;//date, text, select
        //     this.filtrosGlobales.push(obj);
        //   });
        // }
        // });
        this.clickDerechoMenu();
        this.InicializarEventoViewChange(this);
    }
    /**
     * @return {?}
     */
    crearLayersBusqueda() {
        /** @type {?} */
        let strokeProp = new Stroke({ color: 'black', width: 2 });
        /** @type {?} */
        let goldFill = new Fill({ color: 'blue' });
        // let clusterSource = new Cluster({
        //   distance: parseInt('50', 10),
        //   source: new Vector()
        // });
        /** @type {?} */
        let styleCache = {};
        /** @type {?} */
        let style = (/**
         * @param {?} feature
         * @param {?} resolution
         * @return {?}
         */
        (feature, resolution) => {
            /** @type {?} */
            let size = feature.get('features').length;
            // console.log('Feature style',feature);
            /** @type {?} */
            let style;
            /** @type {?} */
            let total = 0;
            feature.get('features').forEach((/**
             * @param {?} element
             * @return {?}
             */
            element => {
                total += parseInt(element.values_.total);
            }));
            if (size == 1) {
                console.log("total", feature.get('features')[0].values_.total);
                total = feature.get('features')[0].values_.total;
            }
            console.log(total);
            if (total > 1) {
                console.log("feature Style", feature);
                /** @type {?} */
                let color = total > 25 ? "192,0,0" : total > 8 ? "255,128,0" : "0,128,0";
                /** @type {?} */
                let radius = Math.max(8, Math.min(total * 0.75, 20));
                /** @type {?} */
                let dash1 = 2 * Math.PI * radius / 6;
                /** @type {?} */
                let dash2 = [0, dash1, dash1, dash1, dash1, dash1, dash1];
                style = styleCache[total] = new Style({
                    image: new CircleStyle({
                        radius: radius,
                        stroke: new Stroke({
                            color: "rgba(" + color + ",0.5)",
                            width: 15,
                            lineDash: dash2,
                            lineCap: "butt"
                        }),
                        fill: new Fill({
                            color: "rgba(" + color + ",1)"
                        })
                    }),
                    text: new Text({
                        text: total.toString(),
                        fill: new Fill({
                            color: '#fff'
                        })
                    })
                });
                return [style];
            }
            else {
                try {
                    /** @type {?} */
                    let feat = feature.get('features');
                    /** @type {?} */
                    let src = feat[0].getStyle().getImage().getSrc();
                    /** @type {?} */
                    let style = feat[0].getStyle();
                    if (!styleCache[src]) {
                        styleCache[src] = style;
                    }
                    return styleCache[src];
                }
                catch (_a) {
                    /** @type {?} */
                    let style = new Style({
                        image: new RegularShape({
                            fill: goldFill,
                            stroke: strokeProp,
                            points: 4,
                            radius: 10,
                            angle: Math.PI / 4
                        }),
                        text: new Text({
                            text: feature.get('features')[0].values_.total,
                            fill: new Fill({
                                color: '#fff'
                            })
                        })
                    });
                    return style;
                }
            }
        });
        /** @type {?} */
        let styleTexto = (/**
         * @param {?} feature
         * @param {?} resolution
         * @return {?}
         */
        (feature, resolution) => {
            /** @type {?} */
            let size = feature.get('features') != undefined ? feature.get('features').length : 1;
            console.log('Feature style', feature);
            /** @type {?} */
            let style;
            if (size > 1) {
                /** @type {?} */
                let color = size > 25 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
                /** @type {?} */
                let radius = Math.max(8, Math.min(size * 0.75, 20));
                /** @type {?} */
                let dash1 = 2 * Math.PI * radius / 6;
                /** @type {?} */
                let dash2 = [0, dash1, dash1, dash1, dash1, dash1, dash1];
                style = styleCache[size] = new Style({
                    image: new CircleStyle({
                        radius: radius,
                        stroke: new Stroke({
                            color: "rgba(" + color + ",0.5)",
                            width: 15,
                            lineDash: dash2,
                            lineCap: "butt"
                        }),
                        fill: new Fill({
                            color: "rgba(" + color + ",1)"
                        })
                    }),
                    text: new Text({
                        text: size.toString(),
                        fill: new Fill({
                            color: '#fff'
                        })
                    })
                });
                return [style];
            }
            else {
                try {
                    /** @type {?} */
                    let feat = feature.get('features');
                    /** @type {?} */
                    let src = feat[0].getStyle().getImage().getSrc();
                    /** @type {?} */
                    let style = feat[0].getStyle();
                    if (!styleCache[src]) {
                        styleCache[src] = style;
                    }
                    return styleCache[src];
                }
                catch (_a) {
                    /** @type {?} */
                    let style = new Style({
                        image: new RegularShape({
                            fill: goldFill,
                            stroke: strokeProp,
                            points: 4,
                            radius: 10,
                            angle: Math.PI / 4
                        }),
                        text: new Text({
                            text: "1",
                            fill: new Fill({
                                color: '#fff'
                            })
                        })
                    });
                    return style;
                }
            }
        })
        // let clusterAnimado = new VectorLayer({
        //   source:clusterSource,
        //   // animationDuration: 700,
        //   style:style
        // })
        ;
        // let clusterAnimado = new VectorLayer({
        //   source:clusterSource,
        //   // animationDuration: 700,
        //   style:style
        // })
        /** @type {?} */
        let styleVector = (/**
         * @param {?} feature
         * @param {?} resolution
         * @return {?}
         */
        (feature, resolution) => {
            /** @type {?} */
            let size = feature.get('total') || 1;
            // console.log('Size',size);
            /** @type {?} */
            let style;
            if (size > 1) {
                /** @type {?} */
                let color = size > 25 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
                /** @type {?} */
                let radius = Math.max(8, Math.min(size * 0.75, 20));
                /** @type {?} */
                let dash1 = 2 * Math.PI * radius / 6;
                /** @type {?} */
                let dash2 = [0, dash1, dash1, dash1, dash1, dash1, dash1];
                style = styleCache[size] = new Style({
                    image: new CircleStyle({
                        radius: radius,
                        stroke: new Stroke({
                            color: "rgba(" + color + ",0.5)",
                            width: 15,
                            lineDash: dash2,
                            lineCap: "butt"
                        }),
                        fill: new Fill({
                            color: "rgba(" + color + ",1)"
                        })
                    }),
                    text: new Text({
                        text: size.toString(),
                        fill: new Fill({
                            color: '#fff'
                        })
                    })
                });
                return [style];
            }
            else {
                try {
                    /** @type {?} */
                    let feat = feature.get('features');
                    /** @type {?} */
                    let src = feat[0].getStyle().getImage().getSrc();
                    /** @type {?} */
                    let style = feat[0].getStyle();
                    if (!styleCache[src]) {
                        styleCache[src] = style;
                    }
                    return styleCache[src];
                }
                catch (_a) {
                    /** @type {?} */
                    let style = new Style({
                        image: new RegularShape({
                            fill: goldFill,
                            stroke: strokeProp,
                            points: 4,
                            radius: 10,
                            angle: Math.PI / 4
                        }),
                        text: new Text({
                            text: "1",
                            fill: new Fill({
                                color: '#fff'
                            })
                        })
                    });
                    return style;
                }
            }
        });
        this.busquedaFacetLayer = new Vector$1({
            style: styleVector,
            source: new Vector()
        });
        this.busquedaTextoLayer = new Vector$1({
            style: styleTexto,
            source: new Cluster({
                distance: parseInt('50', 10),
                source: new Vector()
            })
        });
        this.busquedaClusterLayer = new Vector$1({
            style: style,
            source: new Cluster({
                distance: parseInt('50', 10),
                source: new Vector()
            })
        });
        this.map.addLayer(this.busquedaFacetLayer);
        this.map.addLayer(this.busquedaClusterLayer);
        this.map.addLayer(this.busquedaTextoLayer);
        console.log("Se agrego los layer Facet,Cluster!!", this.map.getLayers());
    }
    /**
     * @param {?} index
     * @param {?} iconos
     * @return {?}
     */
    crearEstilo(index, iconos) {
        /** @type {?} */
        let StylePrefab1 = ((/**
         * @param {?} feature
         * @return {?}
         */
        feature => {
            /** @type {?} */
            let styleCache = {};
            if (feature) {
                /** @type {?} */
                let size = feature.get('features').length || 0;
                if (size > 1) {
                    /** @type {?} */
                    let color = size > 25 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
                    /** @type {?} */
                    let radius = Math.max(8, Math.min(size * 0.75, 20));
                    styleCache[size] = new Style({
                        image: new CircleStyle({
                            radius: radius,
                            stroke: new Stroke({
                                color: "rgba(" + color + ",0.3)",
                                width: 15,
                                // lineDash: dash2,
                                lineCap: "butt"
                            }),
                            fill: new Fill({
                                color: "rgba(" + color + ",0.8)"
                            })
                        }),
                        text: new Text({
                            text: size.toString(),
                            fill: new Fill({
                                color: '#fff'
                            })
                        })
                    });
                    return styleCache[size];
                }
                else if (size == 1) {
                    // console.log("Object feature=>>>",feature['values_']['features'][0]);
                    try {
                        /** @type {?} */
                        let ftre = feature['values_']['features'][0];
                        /** @type {?} */
                        let stilo;
                        iconos.valores.forEach((/**
                         * @param {?} valor
                         * @return {?}
                         */
                        valor => {
                            // if(ftre["values_"]["content"][iconos.campo]==){
                            if (ftre["values_"][iconos.campo] == valor.valor) {
                                stilo = new Style({
                                    image: new Icon({
                                        anchor: [0.5, 20],
                                        anchorXUnits: IconAnchorUnits.FRACTION,
                                        anchorYUnits: IconAnchorUnits.PIXELS,
                                        crossOrigin: 'anonymous',
                                        src: valor.path,
                                        scale: valor.escala
                                    })
                                });
                                return;
                            }
                        }));
                        return stilo;
                    }
                    catch (_a) {
                        /** @type {?} */
                        let color = "0,128,0";
                        /** @type {?} */
                        let radius = Math.max(8, Math.min(0.75, 20));
                        styleCache[size] = new Style({
                            image: new CircleStyle({
                                radius: radius,
                                stroke: new Stroke({
                                    color: "rgba(" + color + ",0.3)",
                                    width: 15,
                                    lineCap: "butt"
                                }),
                                fill: new Fill({
                                    color: "rgba(" + color + ",0.8)"
                                })
                            }),
                            text: new Text({
                                text: "1",
                                fill: new Fill({
                                    color: '#fff'
                                })
                            })
                        });
                    }
                    return styleCache[size];
                }
                else {
                    /** @type {?} */
                    let color = "0,128,0";
                    /** @type {?} */
                    let radius = Math.max(8, Math.min(0.75, 20));
                    styleCache[size] = new Style({
                        image: new CircleStyle({
                            radius: radius,
                            stroke: new Stroke({
                                color: "rgba(" + color + ",0.3)",
                                width: 15,
                                lineCap: "butt"
                            }),
                            fill: new Fill({
                                color: "rgba(" + color + ",0.8)"
                            })
                        }),
                        text: new Text({
                            text: "1",
                            fill: new Fill({
                                color: '#fff'
                            })
                        })
                    });
                }
            }
        }));
        if (index == 0) {
            return StylePrefab1;
        }
        else {
            return StylePrefab1;
        }
        // this.stylePrefab[0]=StylePrefab1;
        // this.stylePrefab[0]=StylePrefab1;
        // this.stylePrefab[0]=StylePrefab1;
        /*
        CREAR Y AGREGAR OTRO ESTILOS POSIBLES DEL FEATURE
        
        
        
        */
    }
    /**
     * @param {?} configSource
     * @return {?}
     */
    generarSource(configSource) {
        /** @type {?} */
        let extentString;
        switch (configSource.tipoEntrada) {
            case "WFS":
                return new Cluster({
                    distance: parseInt('50', 10),
                    source: new Vector({
                        format: new WFS(),
                        url: (/**
                         * @param {?} extent
                         * @return {?}
                         */
                        (extent) => {
                            if (extent[0] == Infinity)
                                return "";
                            extentString = extent.join(',');
                            // console.log("Extent=>>>>>>>>>>",extentString);
                            return `${configSource.URL}&bbox=${extentString},${configSource.projection}`;
                        }),
                        strategy: (/**
                         * @return {?}
                         */
                        () => {
                            // console.log(this.map.getView().getZoom());
                            if (this.map.getView().getZoom() <= configSource.minZoom) {
                                // console.log("Min Zoom",this.map)
                                return bbox(createEmpty(), 0);
                            }
                            else
                                return bbox(this.map.getView().calculateExtent(this.map.getSize()), this.map.getView().getResolutionForExtent(this.map.getView().calculateExtent(this.map.getSize())));
                        })
                    })
                });
                break;
            case "WMS":
                console.log("WMS", configSource.URL);
                return new TileWMS({
                    url: configSource.URL,
                    params: { 'LAYERS': configSource.Params['layers'], 'TILED': configSource.Params['tiled'] },
                    projection: configSource.projection,
                    serverType: configSource.serverType
                });
                break;
            case "GML2":
                return new Cluster({
                    distance: parseInt('50', 10),
                    source: new Vector({
                        format: new GML2(),
                        url: (/**
                         * @param {?} extent
                         * @return {?}
                         */
                        (extent) => {
                            if (extent[0] == Infinity)
                                return "";
                            extentString = extent.join(',');
                            // console.log("Extent=>>>>>>>>>>",extentString);
                            return `${configSource.URL}&bbox=${extentString},${configSource.projection}`;
                        }),
                        strategy: (/**
                         * @return {?}
                         */
                        () => {
                            // console.log(this.map.getView().getZoom());
                            if (this.map.getView().getZoom() <= configSource.minZoom) {
                                // console.log("Min Zoom",this.map)
                                return bbox(createEmpty(), 0);
                            }
                            else
                                return bbox(this.map.getView().calculateExtent(this.map.getSize()), this.map.getView().getResolutionForExtent(this.map.getView().calculateExtent(this.map.getSize())));
                        })
                    })
                });
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} configLayer
     * @param {?} source
     * @return {?}
     */
    generarLayer(configLayer, source) {
        /** @type {?} */
        let styleFunction = this.crearEstilo(configLayer.stylePrefab, configLayer.iconos);
        switch (configLayer.tipoSalida) {
            case "Vector":
                if (configLayer.maxResolution) {
                    return new Vector$1({
                        source: source,
                        visible: configLayer.visible,
                        maxResolution: configLayer.maxResolution,
                        style: styleFunction
                    });
                }
                else {
                    return new Vector$1({
                        source: source,
                        visible: configLayer.visible,
                        style: styleFunction
                    });
                }
                break;
            case "animatedCluster":
                if (configLayer.maxResolution) {
                    console.log("Se le aplico un max resolution");
                    return new AnimatedCluster({
                        maxResolution: configLayer.maxResolution,
                        source: source,
                        animationDuration: 700,
                        style: styleFunction,
                        visible: configLayer.visible
                    });
                }
                else {
                    return new AnimatedCluster({
                        source: source,
                        animationDuration: 700,
                        style: styleFunction,
                        visible: configLayer.visible
                    });
                }
                break;
            case "Tile":
                if (configLayer.maxResolution) {
                    return new TileLayer({
                        source: source,
                        visible: configLayer.visible,
                        maxResolution: configLayer.maxResolution
                    });
                }
                else {
                    return new TileLayer({
                        source: source,
                        visible: configLayer.visible
                    });
                }
                break;
            default:
                break;
        }
    }
    /**
     * @param {?} features
     * @return {?}
     */
    createIntersectionYDiferenciaAutomatica(features) {
        return new Promise((/**
         * @param {?} resolve2
         * @return {?}
         */
        resolve2 => {
            /** @type {?} */
            let parser = new io.OL3Parser();
            parser.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
            /** @type {?} */
            let jstsFeatures = [];
            // let intersection;
            features.forEach((/**
             * @param {?} feature
             * @return {?}
             */
            feature => {
                console.log("FIGURA >>", feature);
                /** @type {?} */
                let jstsGeom = parser.read(feature.getGeometry());
                jstsFeatures.push(jstsGeom);
            }));
            if (jstsFeatures.length == 2) {
                /** @type {?} */
                let AB = jstsFeatures[0].intersection(jstsFeatures[1]);
                this.insertarFeatureJSTS(parser, AB).then((/**
                 * @param {?} resolve
                 * @return {?}
                 */
                (resolve) => {
                    console.log(resolve, 'AB');
                    /** @type {?} */
                    let A = jstsFeatures[0].difference(AB);
                    this.insertarFeatureJSTS(parser, A).then((/**
                     * @param {?} resolve
                     * @return {?}
                     */
                    (resolve) => {
                        console.log(resolve, 'A');
                        /** @type {?} */
                        let B = jstsFeatures[1].difference(AB);
                        this.insertarFeatureJSTS(parser, B).then((/**
                         * @param {?} resolve
                         * @return {?}
                         */
                        (resolve) => {
                            console.log(resolve, 'B');
                            features.forEach((/**
                             * @param {?} feature
                             * @return {?}
                             */
                            feature => this.source.removeFeature(feature)));
                            this.modoInterseccionAutomatica = false;
                            this.Intersecciones = [];
                            resolve2("Se ejecuto createIntersectionYDiferenciaAutomatica Correctamente");
                        }));
                    }));
                }));
            }
            else if (jstsFeatures.length == 3) {
                /** @type {?} */
                let AC = jstsFeatures[0].intersection(jstsFeatures[2]);
                this.insertarFeatureJSTS(parser, AC).then((/**
                 * @param {?} resolve
                 * @return {?}
                 */
                (resolve) => {
                    console.log(resolve, "AC");
                    /** @type {?} */
                    let BC = jstsFeatures[1].intersection(jstsFeatures[2]);
                    this.insertarFeatureJSTS(parser, BC).then((/**
                     * @param {?} resolve
                     * @return {?}
                     */
                    (resolve) => {
                        console.log(resolve, "BC");
                        /** @type {?} */
                        let AB = jstsFeatures[0].intersection(jstsFeatures[1]);
                        this.insertarFeatureJSTS(parser, AB).then((/**
                         * @param {?} resolve
                         * @return {?}
                         */
                        (resolve) => {
                            console.log(resolve, "AB");
                            /** @type {?} */
                            let ABC = jstsFeatures[2].intersection(jstsFeatures[0].intersection(jstsFeatures[1]));
                            this.insertarFeatureJSTS(parser, ABC).then((/**
                             * @param {?} resolve
                             * @return {?}
                             */
                            (resolve) => {
                                console.log(resolve, "ABC");
                                /** @type {?} */
                                let A = jstsFeatures[0].difference(AC.union(AB));
                                this.insertarFeatureJSTS(parser, A).then((/**
                                 * @param {?} resolve
                                 * @return {?}
                                 */
                                (resolve) => {
                                    console.log(resolve, "A");
                                    /** @type {?} */
                                    let B = jstsFeatures[1].difference(AB.union(BC));
                                    this.insertarFeatureJSTS(parser, B).then((/**
                                     * @param {?} resolve
                                     * @return {?}
                                     */
                                    (resolve) => {
                                        console.log(resolve, "B");
                                        /** @type {?} */
                                        let C = jstsFeatures[2].difference(BC.union(AC));
                                        this.insertarFeatureJSTS(parser, C).then((/**
                                         * @param {?} resolve
                                         * @return {?}
                                         */
                                        (resolve) => {
                                            console.log(resolve, "C");
                                            features.forEach((/**
                                             * @param {?} feature
                                             * @return {?}
                                             */
                                            feature => this.source.removeFeature(feature)));
                                            this.modoInterseccionAutomatica = false;
                                            this.Intersecciones = [];
                                            resolve2("Se ejecuto createIntersectionYDiferenciaAutomatica Correctamente");
                                        }));
                                    }));
                                }));
                            }));
                        }));
                    }));
                }));
            }
        }));
    }
    /**
     * @param {?} features
     * @return {?}
     */
    createIntersection(features) {
        /** @type {?} */
        let parser = new io.OL3Parser();
        parser.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
        /** @type {?} */
        let jstsFeatures = [];
        // let intersection;
        features.forEach((/**
         * @param {?} feature
         * @return {?}
         */
        feature => {
            console.log("FIGURA >>", feature);
            /** @type {?} */
            let jstsGeom = parser.read(feature.getGeometry());
            jstsFeatures.push(jstsGeom);
        }));
        if (jstsFeatures.length == 2) {
            /** @type {?} */
            let AB = jstsFeatures[0].intersection(jstsFeatures[1]);
            this.insertarFeatureJSTS(parser, AB).then((/**
             * @param {?} resolve
             * @return {?}
             */
            (resolve) => {
                console.log(resolve, 'AB');
                this.Intersecciones = [];
            }));
        }
        else if (jstsFeatures.length == 3) {
            /** @type {?} */
            let ABC = jstsFeatures[2].intersection(jstsFeatures[0].intersection(jstsFeatures[1]));
            this.insertarFeatureJSTS(parser, ABC).then((/**
             * @param {?} resolve
             * @return {?}
             */
            (resolve) => {
                console.log(resolve, "ABC");
                this.Intersecciones = [];
            }));
        }
        this.modoInterseccion = false;
    }
    /**
     * @param {?} parser
     * @param {?} featureJSTS
     * @param {?=} source
     * @param {?=} _style
     * @return {?}
     */
    insertarFeatureJSTS(parser, featureJSTS, source = null, _style = null) {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => {
            this.selectedFeatures.clear();
            /** @type {?} */
            let feature = new Feature();
            console.log("featureJSTS", featureJSTS);
            /** @type {?} */
            let ObjGeo = parser.write(featureJSTS);
            if (ObjGeo.getType() == "MultiPolygon") {
                ObjGeo.getPolygons().forEach((/**
                 * @param {?} polygon
                 * @return {?}
                 */
                polygon => {
                    this.insertarFeatureJSTS(parser, parser.read(polygon));
                }));
                resolve("Ez");
                return false;
            }
            console.log("OBJETO GEO WKT=>>>>>", ObjGeo);
            feature.setGeometry(ObjGeo);
            console.log("Color", this.color.toString());
            /** @type {?} */
            let fill = this.color.toString();
            if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                /** @type {?} */
                let cor = this.color.toString();
                /** @type {?} */
                let sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                /** @type {?} */
                let array = sbtr.split(',');
                /** @type {?} */
                let a = array[0];
                /** @type {?} */
                let b = array[1];
                /** @type {?} */
                let c = array[2];
                fill = `rgba(${a},${b},${c},0.5)`;
                console.log(fill);
            }
            /** @type {?} */
            let style = new Style({
                stroke: new Stroke({ color: this.color.toString(), width: 2 }),
                fill: new Fill({ color: fill })
            });
            if (_style != null)
                style = _style;
            feature.setStyle(style);
            /** @type {?} */
            let CoordsLonlat = [];
            /** @type {?} */
            let coordss = ObjGeo.getCoordinates();
            coordss[0].forEach((/**
             * @param {?} coords
             * @return {?}
             */
            coords => {
                /** @type {?} */
                let lonLat = toLonLat(coords);
                CoordsLonlat.push(lonLat[0]);
                CoordsLonlat.push(lonLat[1]);
            }));
            if (source != null)
                source.addFeature(feature);
            else
                this.source.addFeature(feature);
            // this.infoBusquedas.push({
            //   coords:CoordsLonlat,
            //   type:"Polygon",
            //   distance:5,
            //   realizada:false,
            //   extent:feature.getGeometry().getExtent()
            // })
            // this.selectedFeatures.push(feature);
            setTimeout((/**
             * @return {?}
             */
            () => {
                resolve("Completado");
                return feature;
            }), 250);
        }));
    }
    /**
     * @param {?} features
     * @return {?}
     */
    createDiference(features) {
        /** @type {?} */
        let parser = new io.OL3Parser();
        parser.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
        // this.selectedFeatures.clear();
        if (features.length == 2) {
            console.log("features .. ", features);
            /** @type {?} */
            let jstsGeom = parser.read(features[0].getGeometry());
            /** @type {?} */
            let jstsGeom2 = parser.read(features[1].getGeometry());
            /** @type {?} */
            let jstsGeomDiference = jstsGeom2.difference(jstsGeom);
            this.insertarFeatureJSTS(parser, jstsGeomDiference).then((/**
             * @return {?}
             */
            () => {
                this.source.removeFeature(features[1]);
                this.modoDiferencia = false;
                this.Intersecciones = [];
            }));
        }
        if (features.length == 3) {
            /** @type {?} */
            let jstsGeom1 = parser.read(features[0].getGeometry());
            /** @type {?} */
            let jstsGeom2 = parser.read(features[1].getGeometry());
            /** @type {?} */
            let jstsGeom3 = parser.read(features[2].getGeometry());
            /** @type {?} */
            let jstsGeomDiference = jstsGeom3.difference(jstsGeom1);
            /** @type {?} */
            let jstsGeomDiference2 = jstsGeom2.difference(jstsGeom3);
            this.insertarFeatureJSTS(parser, jstsGeomDiference).then((/**
             * @return {?}
             */
            () => {
                this.insertarFeatureJSTS(parser, jstsGeomDiference2).then((/**
                 * @return {?}
                 */
                () => {
                    // this.source.removeFeature(features[1]);
                    // this.source.removeFeature(features[1]);
                    this.modoDiferencia = false;
                    this.Intersecciones = [];
                }));
            }));
        }
    }
    /**
     * @param {?} a
     * @return {?}
     */
    convertJSTSGeometryPolygonToOL3Polygon(a) {
        /**
         * @param {?} p
         * @return {?}
         */
        function p2c(p) {
            return fromLonLat([p.x, p.y]);
        }
        /** @type {?} */
        const rings = [a._shell._points._coordinates.map(p2c)];
        for (let i = 0; i < a._holes.length; i++) {
            rings.push(a._holes[i]._points._coordinates.map(p2c));
        }
        /** @type {?} */
        let po = new Polygon(rings);
        return po;
    }
    //Procesamiento de datos para crear una inserccion
    /**
     * @param {?} map
     * @param {?} This
     * @param {?} container
     * @param {?} overlay
     * @return {?}
     */
    eventoClick(map, This, container, overlay) {
        map.on('click', (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            console.log("click", event);
            if (This.procesandoFeature) {
                This.selectedFeatures.clear();
                return;
            }
            if (This.utilizandoPopUp == false)
                container.innerHTML = "";
            else
                This.utilizandoPopUp = true;
            This.Intersecciones = [];
            //Si en este loop tiene mas de dos feature entra a interseccion.
            map.forEachFeatureAtPixel(event.pixel, (/**
             * @param {?} feature
             * @param {?} layer
             * @return {?}
             */
            function (feature, layer) {
                // if(This.modoInterseccionAutomatica || This.modoInterseccion || This.modoDiferencia){
                // console.log(feature);
                if (feature.getGeometry().getType() == "Polygon") {
                    This.Intersecciones.push(feature);
                    console.log(This.Intersecciones);
                }
                // }
            }));
            if (This.Intersecciones.length > 1) {
                // setTimeout(() => {
                This.procesandoFeature = true;
                This.createIntersectionYDiferenciaAutomatica(This.Intersecciones).then((/**
                 * @param {?} resolve
                 * @return {?}
                 */
                (resolve) => {
                    console.log(resolve);
                    This.procesandoFeature = false;
                }));
                // }, 1000);
            }
            if (This.modoInterseccionAutomatica) {
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    This.createIntersectionYDiferenciaAutomatica(This.Intersecciones);
                }), 1000);
            }
            if (This.modoInterseccion) {
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    This.createIntersection(This.Intersecciones);
                }), 1000);
            }
            if (This.modoDiferencia) {
                This.createDiference(This.Intersecciones);
            }
            else if (This.Intersecciones.length > 3) {
                This.Intersecciones = [];
            }
        }));
    }
    /**
     * @param {?} Coordenadas
     * @param {?} Tipo
     * @param {?} Distance
     * @param {?} extent
     * @return {?}
     */
    busquedaGeo(Coordenadas, Tipo, Distance, extent) {
        if (this.utilizandoPopUp) {
            this.utilizandoPopUp = false;
        }
        this.content.innerHTML = "";
        /** @type {?} */
        let Layers = this.map.getLayerGroup();
        /** @type {?} */
        let a = 1000;
        Layers.getLayersArray().forEach((/**
         * @param {?} element
         * @return {?}
         */
        element => {
            element.setZIndex(a);
            a++;
        }));
        /** @type {?} */
        let centro;
        /** @type {?} */
        let coords = Coordenadas || [-120.0146484375, 32.805744732906874, -120.0146484375, 12.082295837363588, -82.529296875, 12.082295837363588, -82.529296875, 32.805744732906874, -120.0146484375, 32.805744732906874];
        Tipo = Tipo || 'Rectangle';
        // centro pensando que siempre es un cuadrado
        /** @type {?} */
        let p1 = [coords[0], coords[1]];
        /** @type {?} */
        let p2 = [coords[4], coords[5]];
        centro = this.calcularPuntoMedio(p1, p2);
        /** @type {?} */
        let Coords3 = coords;
        /** @type {?} */
        let Coords4 = [];
        for (let index = 0; index < Coords3.length; index += 2) {
            Coords4 = toLonLat([Coords3[index], Coords3[index + 1]]);
        }
        if (Distance == undefined) {
            Distance = 5;
        }
        if (Tipo != 'Rectangle') {
            Coords4 = coords;
            centro = fromLonLat(centro);
        }
        else if (Tipo == 'Rectangle') ;
        else if (Tipo == 'Circle') {
            centro = fromLonLat(Coordenadas);
        }
        if (Coords4[0] > 0 && Coords4[0] < 1 || Coords4[0] < 0 && Coords4[0] > -1) {
            Coords4 = coords;
            centro = fromLonLat(centro);
        }
        if (isNaN(centro[0])) {
            centro = fromLonLat(Coordenadas);
        }
        this.coordenadasActual = Coords4;
        // this.cursorOriginal();
        this.map.removeInteraction(this.draw);
        /** @type {?} */
        let polygonWKT = "POLYGON ((";
        /** @type {?} */
        let coordsX = [];
        /** @type {?} */
        let coordsY = [];
        /** @type {?} */
        let b = 1;
        for (let index = 0; index < Coords4.length; index++) {
            if (b == 1) {
                coordsX.push(Coords4[index]);
                b++;
            }
            else if (b == 2) {
                coordsY.push(Coords4[index]);
                b = 1;
            }
        }
        for (let i = 0; i < coordsX.length; i++) {
            polygonWKT += `${coordsX[i]} ${coordsY[i]},`;
        }
        polygonWKT = polygonWKT.slice(0, polygonWKT.length - 1);
        polygonWKT += "))";
        console.log(polygonWKT);
        //intersectsCoordinate(coordinate)
        this.figurasActivas.push(polygonWKT);
        this.spinner.hide();
        // this.consultarV2();
    }
    /**
     * @param {?} selectedFeatures
     * @param {?} This
     * @return {?}
     */
    selectedOn(selectedFeatures, This) {
        selectedFeatures.on(['add'], (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            console.log("This.paginacionGeo.geometrysWKT", This.paginacionGeo.geometrysWKT);
            console.log("This.paginacionGeo.UUID", This.paginacionGeo.UUID);
            /** @type {?} */
            let tiposOrigen = "";
            This.tiposOrigenes.forEach((/**
             * @param {?} tipo
             * @return {?}
             */
            tipo => {
                if (tipo != null) {
                    tiposOrigen += `tipoOrigen=${tipo};`;
                }
            }));
            tiposOrigen = tiposOrigen.slice(0, tiposOrigen.length - 1);
            This.paginacionGeo.tipoOrigen = tiposOrigen;
            // if(This.teclaPresionada=="Control"){
            //   This.featuresSeleccionados.push(event['element'])
            //   This.selectedFeatures.clear();
            //   This.featuresSeleccionados.forEach(feature => {
            //     This.selectedFeatures.push(feature);
            //   });
            // }
            console.log(event);
            /** @type {?} */
            let ObjectGeo = event['element'].getGeometry();
            if (ObjectGeo.getType() == "Polygon" || ObjectGeo.getType() == "Circle") {
                return;
            }
            else {
                if (ObjectGeo.getType() == "Point") {
                    //Tipo Resultado Detalle
                    /** @type {?} */
                    let polygon = event['element'].values_.polygon;
                    if (polygon === undefined) {
                        try {
                            polygon = event['element'].values_.features[0].values_.polygon;
                        }
                        catch (_a) {
                            console.log("Error al querer extraer informacion de un feature clusterizado...");
                        }
                    }
                    if (polygon != undefined) {
                        This.paginacionGeo.geometrysWKT = [polygon];
                    }
                    else {
                        This.paginacionGeo.geometrysWKT = null;
                        /** @type {?} */
                        let UUID = event['element'].values_.UUID;
                        /** @type {?} */
                        let UUIDS = [];
                        if (UUID === undefined) {
                            event['element'].values_.features.forEach((/**
                             * @param {?} element
                             * @return {?}
                             */
                            element => {
                                if (element.values_.UUID) {
                                    UUIDS.push(element.values_.UUID);
                                }
                            }));
                            //  UUID = event['element'].values_.features[0].values_.UUID;
                        }
                        This.paginacionGeo.UUID = UUIDS;
                    }
                    if (This.paginacionGeo.geometrysWKT || This.paginacionGeo.UUID.length > 0) {
                        console.log("Polygon Seleccionado", event['element']);
                        This.paginacionGeo.tipoOrigen = tiposOrigen;
                        This.paginacionGeo.pagActual = 1;
                        This.buscarDetalle();
                    }
                    else {
                        /** @type {?} */
                        let features = event['element'].values_.features;
                        if (features === undefined) {
                            return;
                        }
                        if (features.length > 30)
                            This.spinner.show();
                        setTimeout((/**
                         * @return {?}
                         */
                        () => {
                            features.forEach((/**
                             * @param {?} feature
                             * @return {?}
                             */
                            feature => {
                                console.log(feature);
                                // console.log(feature.values_.data);
                                if (feature.values_.header === undefined) {
                                    // console.log(feature);
                                    return;
                                }
                                /** @type {?} */
                                let header = feature.values_.header;
                                if (typeof (header) == "object") {
                                    header = Object.values(header)[0];
                                }
                                console.log(header);
                                This.llenarPopUp(header, feature, features);
                                if (This.content.innerHTML != "") {
                                    console.log(event);
                                    This.overlay.setPosition(event.element.getGeometry().getCoordinates());
                                    this.utilizandoPopUp = false;
                                }
                                if (features.length > 30)
                                    This.spinner.hide();
                            }));
                        }), 100);
                    }
                }
            }
        }));
    }
    /**
     * @param {?} draw
     * @param {?} source
     * @param {?} map
     * @param {?} overlay
     * @param {?} content
     * @param {?} selectedFeatures
     * @param {?} THIS
     * @param {?} hole
     * @return {?}
     */
    drawOnEvent(draw, source, map, overlay, content, selectedFeatures, THIS, hole) {
        draw.on('drawstart', (/**
         * @param {?} evt
         * @return {?}
         */
        function (evt) {
            console.log(evt.feature);
            console.log("Color", THIS.color.toString());
            /** @type {?} */
            let fill = THIS.color.toString();
            if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                /** @type {?} */
                let cor = THIS.color.toString();
                /** @type {?} */
                let sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                /** @type {?} */
                let array = sbtr.split(',');
                /** @type {?} */
                let a = array[0];
                /** @type {?} */
                let b = array[1];
                /** @type {?} */
                let c = array[2];
                fill = `rgba(${a},${b},${c},0.5)`;
                console.log(fill);
            }
            /** @type {?} */
            let style = new Style({
                stroke: new Stroke({ color: THIS.color.toString(), width: 2 }),
                fill: new Fill({ color: fill })
            });
            evt.feature.setStyle(style);
            // var coordinate=evt.feature.getGeometry().getFirstCoordinate();
            /** @type {?} */
            var coordinate = [evt.feature.getGeometry()['flatCoordinates'][0], evt.feature.getGeometry()['flatCoordinates'][1]];
            hole = map.forEachFeatureAtPixel(map.getPixelFromCoordinate(coordinate), (/**
             * @param {?} feature
             * @return {?}
             */
            function (feature) {
                if ('Polygon' == feature.getGeometry().getType()) {
                    return feature;
                }
            }));
        }));
        draw.on('drawend', (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (hole) {
                /** @type {?} */
                var coordinates = [event.feature.getGeometry()['flatCoordinates'][0], event.feature.getGeometry()['flatCoordinates'][1]];
                console.log(coordinates);
                hole.getGeometry().appendLinearRing(new LinearRing(coordinates));
            }
            console.log("Extent de la figura", event.feature.getGeometry().getExtent());
            console.log("Color", THIS.color.toString());
            /** @type {?} */
            let fill = THIS.color.toString();
            if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                /** @type {?} */
                let cor = THIS.color.toString();
                /** @type {?} */
                let sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                /** @type {?} */
                let array = sbtr.split(',');
                /** @type {?} */
                let a = array[0];
                /** @type {?} */
                let b = array[1];
                /** @type {?} */
                let c = array[2];
                fill = `rgba(${a},${b},${c},0.5)`;
                console.log(fill);
            }
            /** @type {?} */
            let style = new Style({
                stroke: new Stroke({ color: THIS.color.toString(), width: 2 }),
                fill: new Fill({ color: fill })
            });
            console.log("Draw Style", style);
            event.feature.setStyle(style);
            // document.documentElement.style.cursor='default';
            /** @type {?} */
            let Distance = 5;
            /** @type {?} */
            let Type;
            /** @type {?} */
            let Coords3;
            Type = event['feature'].getGeometry().getType();
            Coords3 = event['feature'].getGeometry()['flatCoordinates'];
            /** @type {?} */
            let Dibujar = true;
            switch (Type) {
                case "Polygon":
                    Coords3 = event['feature'].getGeometry()['flatCoordinates'];
                    break;
                case "Circle":
                    /** @type {?} */
                    let newCircle = event.feature.getGeometry();
                    /** @type {?} */
                    let featureFromCircle = fromCircle(newCircle);
                    /** @type {?} */
                    let feature = new Feature(featureFromCircle);
                    Coords3 = [];
                    /** @type {?} */
                    let Coords = featureFromCircle.getCoordinates();
                    Coords[0].forEach((/**
                     * @param {?} coords
                     * @return {?}
                     */
                    coords => {
                        /** @type {?} */
                        let coordsTmp = toLonLat(coords);
                        // console.log(coordsTmp);
                        Coords3.push(coordsTmp[0]);
                        Coords3.push(coordsTmp[1]);
                    }));
                    if (THIS.tipoCirculo == 2) {
                        /** @type {?} */
                        let center = newCircle.getCenter();
                        /** @type {?} */
                        let Radius = newCircle.getRadius();
                        // newCircl
                        /** @type {?} */
                        let top = [center[0], center[1] + Radius];
                        // console.log("Distancia",Radius);
                        /** @type {?} */
                        let lineN = new LineString([[center[0], center[1]], [top[0], top[1]], [center[0], center[1]]]);
                        /** @type {?} */
                        let lineSE = new LineString([[center[0], center[1]], [top[0], top[1]], [center[0], center[1]]]);
                        /** @type {?} */
                        let lineSO = new LineString([[center[0], center[1]], [top[0], top[1]], [center[0], center[1]]]);
                        // let lineS = new LineString([[center[0],center[1]],[bot[0],bot[1]],[center[0],center[1]]]);
                        lineSE.rotate(2.0944, center);
                        lineSO.rotate(4.18879, center);
                        /** @type {?} */
                        let parser = new io.OL3Parser();
                        parser.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
                        /** @type {?} */
                        let jstsGeom = parser.read(featureFromCircle);
                        /** @type {?} */
                        let jstsGeom2 = parser.read(lineN);
                        /** @type {?} */
                        let jstsGeom3 = parser.read(lineSE);
                        /** @type {?} */
                        let jstsGeom4 = parser.read(lineSO);
                        /** @type {?} */
                        let jstsGeomUnion = jstsGeom4.union(jstsGeom2.union(jstsGeom3));
                        /** @type {?} */
                        let union = jstsGeom.getExteriorRing().union(jstsGeomUnion);
                        /** @type {?} */
                        let polygonizer = new operation.polygonize.Polygonizer();
                        polygonizer.add(union);
                        /** @type {?} */
                        let polygons = polygonizer.getPolygons();
                        for (let i = polygons.iterator(); i.hasNext();) {
                            /** @type {?} */
                            let polygon = i.next();
                            THIS.insertarFeatureJSTS(parser, polygon);
                        }
                        // THIS.source.addFeature(new Feature(lineN));
                        // THIS.source.addFeature(new Feature(lineSE));
                        // THIS.source.addFeature(new Feature(lineSO));
                    }
                    else {
                        console.log("Ento a insertar circulo completo");
                        /** @type {?} */
                        let fill = THIS.color.toString();
                        if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                            /** @type {?} */
                            let cor = THIS.color.toString();
                            /** @type {?} */
                            let sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                            /** @type {?} */
                            let array = sbtr.split(',');
                            /** @type {?} */
                            let a = array[0];
                            /** @type {?} */
                            let b = array[1];
                            /** @type {?} */
                            let c = array[2];
                            fill = `rgba(${a},${b},${c},0.5)`;
                            console.log(fill);
                        }
                        /** @type {?} */
                        let style = new Style({
                            stroke: new Stroke({ color: THIS.color.toString(), width: 2 }),
                            fill: new Fill({ color: fill })
                        });
                        feature.setStyle(style);
                        THIS.source.addFeature(feature);
                    }
                    setTimeout((/**
                     * @return {?}
                     */
                    () => {
                        THIS.source.removeFeature(event.feature);
                    }), 200);
                    THIS.infoBusquedas.push({
                        coords: Coords3,
                        type: 'Polygon',
                        distance: 5,
                        realizada: false,
                        extent: featureFromCircle.getExtent()
                    });
                    THIS.cursorOriginal();
                    THIS.map.removeInteraction(THIS.draw);
                    // let distancia = getDistance(toLonLat(Coords3),toLonLat(coords));
                    // Distance =    (Math.round(distancia / 1000 * 100) / 100);
                    break;
                case "Rectangle":
                    break;
                case "Point":
                    console.log("Type", Type);
                    console.log("tipoCirculo", THIS.tipoCirculo);
                    Dibujar = false;
                    /** @type {?} */
                    let Radius;
                    // let Type; 
                    /** @type {?} */
                    let Coords4 = [];
                    THIS.utilizandoPopUp = true;
                    THIS.content.innerHTML = `<div><label>Radio</label>
          <input type='text' id='input'>
          <select id="typeDistance">
            <option value="metros">Metros</option>
            <option value="millas">Millas</option>
            <option value="kilometros">Kilometros</option>
          </select>
          <button id='btnPopupAceptar'>Aceptar</button>
          </div>`;
                    overlay.setPosition(event['feature'].getGeometry()['flatCoordinates']);
                    document.getElementById('btnPopupAceptar').onclick = (/**
                     * @return {?}
                     */
                    () => {
                        source.removeFeature(event['feature']);
                        /** @type {?} */
                        let distance = document.getElementById('input');
                        document.getElementById('scroll').scrollTo(0, 0);
                        overlay.setPosition(undefined);
                        /** @type {?} */
                        let LayersArray = map.getLayerGroup().getLayers();
                        Radius = parseFloat(distance['value']);
                        /** @type {?} */
                        let Option = document.getElementById('typeDistance');
                        if (Option['value'] == 'millas') {
                            Radius = Radius * 1609.34;
                        }
                        else if (Option['value'] == 'kilometros') {
                            Radius = Radius * 1000;
                        }
                        /** @type {?} */
                        let NewCircle = new Circle(event['feature'].getGeometry()['flatCoordinates'], Radius);
                        /** @type {?} */
                        let circlePolygon = fromCircle(NewCircle);
                        Type = circlePolygon.getType();
                        /** @type {?} */
                        let Coords3;
                        Coords3 = circlePolygon['flatCoordinates'];
                        // Coords3=NewCircle.getCenter();
                        // let coords = NewCircle.getLastCoordinate();
                        // let distancia = getDistance(toLonLat(Coords3),toLonLat(coords));
                        if (THIS.tipoCirculo == 2) {
                            /** @type {?} */
                            let center = NewCircle.getCenter();
                            /** @type {?} */
                            let top = [center[0], center[1] + Radius];
                            console.log("Distancia", Radius);
                            /** @type {?} */
                            let lineN = new LineString([[center[0], center[1]], [top[0], top[1]], [center[0], center[1]]]);
                            /** @type {?} */
                            let lineSE = new LineString([[center[0], center[1]], [top[0], top[1]], [center[0], center[1]]]);
                            /** @type {?} */
                            let lineSO = new LineString([[center[0], center[1]], [top[0], top[1]], [center[0], center[1]]]);
                            // let lineS = new LineString([[center[0],center[1]],[bot[0],bot[1]],[center[0],center[1]]]);
                            lineSE.rotate(2.0944, center);
                            lineSO.rotate(4.18879, center);
                            /** @type {?} */
                            let parser = new io.OL3Parser();
                            parser.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
                            /** @type {?} */
                            let jstsGeom = parser.read(circlePolygon);
                            /** @type {?} */
                            let jstsGeom2 = parser.read(lineN);
                            /** @type {?} */
                            let jstsGeom3 = parser.read(lineSE);
                            /** @type {?} */
                            let jstsGeom4 = parser.read(lineSO);
                            /** @type {?} */
                            let jstsGeomUnion = jstsGeom4.union(jstsGeom2.union(jstsGeom3));
                            /** @type {?} */
                            let union = jstsGeom.getExteriorRing().union(jstsGeomUnion);
                            /** @type {?} */
                            let polygonizer = new operation.polygonize.Polygonizer();
                            polygonizer.add(union);
                            /** @type {?} */
                            let polygons = polygonizer.getPolygons();
                            for (let i = polygons.iterator(); i.hasNext();) {
                                /** @type {?} */
                                let polygon = i.next();
                                THIS.insertarFeatureJSTS(parser, polygon);
                            }
                            // THIS.source.addFeature(new Feature(lineN));
                            // THIS.source.addFeature(new Feature(lineSE));
                            // THIS.source.addFeature(new Feature(lineSO));
                        }
                        else {
                            /** @type {?} */
                            let feature = new Feature({
                                geometry: circlePolygon,
                                feature: 'Generic Name'
                            });
                            /** @type {?} */
                            let fill = THIS.color.toString();
                            if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                                /** @type {?} */
                                let cor = THIS.color.toString();
                                /** @type {?} */
                                let sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                                /** @type {?} */
                                let array = sbtr.split(',');
                                /** @type {?} */
                                let a = array[0];
                                /** @type {?} */
                                let b = array[1];
                                /** @type {?} */
                                let c = array[2];
                                fill = `rgba(${a},${b},${c},0.2)`;
                                console.log(fill);
                            }
                            /** @type {?} */
                            let style = new Style({
                                stroke: new Stroke({ color: THIS.color.toString(), width: 2 }),
                                fill: new Fill({ color: fill })
                            });
                            feature.setStyle(style);
                            LayersArray.getArray()[2]['values_']['source'].addFeature(feature);
                        }
                        // Distance = (Math.round(distancia / 1000 * 100) / 100);
                        Coords4 = [];
                        /** @type {?} */
                        let ar;
                        for (let index = 0; index < Coords3.length; index++) {
                            ar = toLonLat([Coords3[index], Coords3[index + 1]]);
                            index = index + 1;
                            ar.forEach((/**
                             * @param {?} element
                             * @return {?}
                             */
                            element => {
                                Coords4.push(element);
                            }));
                        }
                        // selectedFeatures.clear();  
                        THIS.infoBusquedas.push({
                            coords: Coords4,
                            type: Type,
                            distance: 5,
                            realizada: false,
                            extent: circlePolygon.getExtent()
                        });
                        THIS.cursorOriginal();
                        THIS.map.removeInteraction(THIS.draw);
                        // THIS.busquedaGeo(Coords4,Type,Distance,false)   
                    });
                    // ClusterSource.getSource().removeFeature(event['feature']);
                    break;
                case "LineString":
                    Coords3 = event['feature'].getGeometry()['flatCoordinates'];
                    if (Coords3.length > 4) {
                        Type = "Polygon";
                    }
                    break;
                default:
                    break;
            }
            setTimeout((/**
             * @return {?}
             */
            () => {
                THIS.selectedFeatures.clear();
            }), 300);
            if (Dibujar) {
                /** @type {?} */
                let Coords4 = [];
                /** @type {?} */
                let ar;
                for (let index = 0; index < Coords3.length; index++) {
                    ar = toLonLat([Coords3[index], Coords3[index + 1]]);
                    index = index + 1;
                    ar.forEach((/**
                     * @param {?} element
                     * @return {?}
                     */
                    element => {
                        Coords4.push(element);
                    }));
                }
                // source.getFeatures().forEach(element=>{
                //   source.removeFeature(element);
                // })  
                if (Type == "Circle")
                    return;
                THIS.infoBusquedas.push({
                    coords: Coords4,
                    type: Type,
                    distance: Distance,
                    realizada: false,
                    extent: event['feature'].getGeometry().getExtent()
                });
                console.log("InfoBusquedas", THIS.infoBusquedas);
                // console.log(event['feature']);
                // setTimeout(() => {
                //   THIS.source.removeFeature(event['feature']);
                // }, 1000);
            }
            THIS.cursorOriginal();
            THIS.map.removeInteraction(THIS.draw);
        }));
    }
    /**
     * @param {?} tipoDibujo
     * @return {?}
     */
    addDraw(tipoDibujo) {
        /** @type {?} */
        let fill = this.color.toString();
        if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
            /** @type {?} */
            let cor = this.color.toString();
            /** @type {?} */
            let sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
            /** @type {?} */
            let array = sbtr.split(',');
            /** @type {?} */
            let a = array[0];
            /** @type {?} */
            let b = array[1];
            /** @type {?} */
            let c = array[2];
            fill = `rgba(${a},${b},${c},0.5)`;
            console.log(fill);
        }
        /** @type {?} */
        let style = new Style({
            stroke: new Stroke({ color: this.color.toString(), width: 2 }),
            fill: new Fill({ color: fill })
        });
        console.log("Style actual", style);
        this.draw = new Draw({
            source: this.source,
            type: tipoDibujo,
            style: style
        });
        this.map.addInteraction(this.draw);
        this.cursorCruz();
    }
    /**
     * @param {?} clos
     * @param {?} Selecteddfeatures
     * @param {?} overlay
     * @param {?} THIS
     * @return {?}
     */
    cerrarPopup(clos, Selecteddfeatures, overlay, THIS) {
        clos.onclick = (/**
         * @return {?}
         */
        function () {
            THIS.utilizandoPopUp = false;
            document.getElementById('scroll').scrollTo(0, 0);
            overlay.setPosition(undefined);
            clos.blur();
            // Selecteddfeatures.clear();
            return false;
        });
    }
    /**
     * @return {?}
     */
    cerrarPopUpV2() {
        if (this.showOption)
            this.showOption = false;
        this.ocultarClickDerechoMenu();
        if (!this.utilizandoPopUp) {
            // if(this.overlay.
            // )
            if (this.overlay.getPosition() != undefined) {
                // document.getElementById('scroll').scrollTo(0,0);
                this.overlay.setPosition(undefined);
                this.closer.blur();
                // this.selectedFeatures.clear();
            }
        }
    }
    /**
     * @param {?} stringUTC
     * @return {?}
     */
    UTCaLocal(stringUTC) {
        /** @type {?} */
        let fecha = Date.parse(stringUTC);
        /** @type {?} */
        let fechaUTC = new Date(fecha);
        /** @type {?} */
        let offset = fechaUTC.getTimezoneOffset() * 60000;
        /** @type {?} */
        let milisegundos = fechaUTC.getTime() - offset;
        return new Date(milisegundos);
    }
    /**
     * @param {?} map
     * @param {?} selectedFeatures
     * @return {?}
     */
    eventDoubleClick(map, selectedFeatures) {
        map.on('dblclick', (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            // selectedFeatures.clear();
            /** @type {?} */
            let features = [];
            map.forEachFeatureAtPixel(event.pixel, (/**
             * @param {?} feature
             * @param {?} Layer
             * @return {?}
             */
            function (feature, Layer) {
                features = feature['values_']['features'];
                /** @type {?} */
                let extent = createEmpty();
                if (features) {
                    features.forEach((/**
                     * @param {?} f
                     * @param {?} index
                     * @param {?} array
                     * @return {?}
                     */
                    function (f, index, array) {
                        extend(extent, f.getGeometry().getExtent());
                    }));
                    map.getView().fit(extent);
                }
            }));
        }));
    }
    /**
     * @param {?} map
     * @return {?}
     */
    desactivarZoomDobleClick(map) {
        /** @type {?} */
        let dblClickInteraction;
        map.getInteractions().getArray().forEach((/**
         * @param {?} interaction
         * @return {?}
         */
        function (interaction) {
            if (interaction instanceof DoubleClickZoom) {
                dblClickInteraction = interaction;
            }
        }));
        map.removeInteraction(dblClickInteraction);
    }
    /**
     * @param {?} clusterSource
     * @return {?}
     */
    ajustarZoom(clusterSource) {
        /** @type {?} */
        let originalFeatures = clusterSource.getSource().getFeatures();
        /** @type {?} */
        let extent = createEmpty();
        originalFeatures.forEach((/**
         * @param {?} f
         * @param {?} index
         * @param {?} array
         * @return {?}
         */
        function (f, index, array) {
            extend(extent, f.getGeometry().getExtent());
        }));
        this.map.getView().fit(extent);
    }
    /**
     * @param {?} fecha
     * @param {?} tipo
     * @return {?}
     */
    obtenerFechaFormateada(fecha, tipo) {
        // console.log(fecha)
        if (fecha.month == undefined || fecha.day == undefined || fecha.year == undefined) {
            // 2019-03-04T16:59:45Z
            /** @type {?} */
            let day = fecha.substr(8, 2);
            /** @type {?} */
            let month = fecha.substr(5, 2);
            /** @type {?} */
            let year = fecha.substr(0, 4);
            return `${day}/${month}/${year}`;
        }
        /** @type {?} */
        let month = fecha['month'];
        // month = month < 10 ? '0'+ month: month + "";
        /** @type {?} */
        let day = fecha['day'];
        /** @type {?} */
        let year = fecha['year'];
        console.log(`${year}/${month}/${day}`);
        if (tipo)
            return year + "-" + (month < 10 ? '0' + month : month) + "-" + (day < 10 ? '0' + day : day) + (tipo == 1 ? 'T00:00:00Z' : 'T23:59:00Z');
        if (!tipo)
            return year + "-" + (month < 10 ? '0' + month : month) + "-" + (day < 10 ? '0' + day : day);
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    funcionesMenu(obj) {
        switch (obj) {
            // ********** MAPAS ***************
            case 'OSM':
                this.googleLayer.setVisible(false);
                this.OSMLayer.setVisible(true);
                break;
            case 'Google':
                this.OSMLayer.setVisible(false);
                this.googleLayer.setVisible(true);
                break;
            case 'mapCalor':
                console.log("Maapa Calor Activado!!!!");
                this.statusMapaCalor = true;
                this.consultarV2();
                // this.mapaCalorActivo=true;
                break;
            case 'mapPuntos':
                console.log("Mapa Puntos Activado!!!!");
                this.statusMapaCalor = false;
                this.consultarV2();
                // this.mapaCalorActivo=false;
                break;
            // ********** TIPOS DE DIBUJO ***************      
            default:
                console.log(this.map.getInteractions());
                switch (obj) {
                    case 'Circle': //Circulo normal
                        this.tipoSeleccionado = obj;
                        this.tipoCirculo = 0;
                        break;
                    case 'circleOpt1': //Circulo normal x medidas
                        this.tipoSeleccionado = 'Point';
                        this.tipoCirculo = 1;
                        break;
                    case 'circleOpt2': //Circulo dividido x medidas
                        this.tipoSeleccionado = 'Point';
                        this.tipoCirculo = 2;
                        break;
                    case 'circleOpt3': //Circulo dividido
                        this.tipoSeleccionado = 'Circle';
                        this.tipoCirculo = 2;
                        break;
                    case 'Polygon': //poligono
                        this.tipoSeleccionado = 'Polygon';
                        this.tipoCirculo = 0;
                        break;
                    default:
                        break;
                }
                if (this.draw)
                    this.map.removeInteraction(this.draw);
                this.addDraw(this.tipoSeleccionado);
                this.drawOnEvent(this.draw, this.source, this.map, this.overlay, this.content, this.selectedFeatures, this, this.hole);
                break;
        }
    }
    /**
     * @return {?}
     */
    eliminarTodo() {
        this.buscando = false;
        this.isCollapsedR = true;
        this.chkActualizarResult = false;
        this.buscarArea.nativeElement.style.display = `none`;
        this.labelActualizar.nativeElement.style.display = "none";
        this.busquedaTextoLayer.getSource().getSource().clear();
        this.busquedaClusterLayer.getSource().getSource().clear();
        this.busquedaFacetLayer.getSource().clear();
        this.mapaCalor.getSource().clear();
        this.figurasActivas = [];
        this.Intersecciones = [];
        this.totalEncontrados = 0;
        this.infoBusquedas = [];
        this.source.getFeatures().forEach((/**
         * @param {?} figura
         * @return {?}
         */
        figura => {
            this.source.removeFeature(figura);
        }));
        this.busquedasActuales.forEach((/**
         * @param {?} busquedas
         * @return {?}
         */
        busquedas => {
            busquedas.cluster.getSource().clear(true);
        }));
        // this.arregloCapas.forEach(capa=>{
        //   capa.cluster.getSource().getSource().getFeatures().forEach(Feature=>{
        //     capa.cluster.getSource().getSource().removeFeature(Feature);
        //   })
        // // this.clusterSource.getSource().addFeature(feature);
        // })
        this.selectCluster.clear();
        // this.selectedFeatures.clear();
    }
    /**
     * @return {?}
     */
    eliminarSeleccionado() {
        this.ocultarClickDerechoMenu();
        if (this.selectedFeatures['array_'][0]) {
            console.log("Se eliminó >>>", this.selectedFeatures['array_'][0]);
            this.source.removeFeature(this.selectedFeatures['array_'][0]);
            this.selectedFeatures.clear();
        }
        this.consultarV2();
    }
    /**
     * @return {?}
     */
    cursorCruz() {
        // let cursores=['default','crosshair','n-resizea','move','ne-resize','nw-resize','pointer ','se-resize','sw-resize','textm','w-resize','wait'];    
        document.documentElement.style.cursor = 'crosshair';
    }
    /**
     * @return {?}
     */
    cursorOriginal() {
        document.documentElement.style.cursor = "default";
    }
    /**
     * @return {?}
     */
    botonBuscar() {
        this.busquedasActuales.forEach((/**
         * @param {?} busquedas
         * @return {?}
         */
        busquedas => {
            busquedas.cluster.getSource().clear(true);
        }));
        this.buscando = true;
        this.cursorOriginal();
        this.totalEncontrados = 0;
        this.figurasActivas = [];
        // this.arregloCapas.forEach(capa=>{
        //   capa.cluster.getSource().getSource().getFeatures().forEach(Feature=>{
        //    capa.cluster.getSource().getSource().removeFeature(Feature);
        //   })
        // })
        if (this.selectedFeatures['array_'].length > 0) {
            this.buscarEnFiguraSeleccionada();
            return true;
        }
        else if (this.infoBusquedas.length == 0) {
            /** @type {?} */
            let extent = this.map.getView().calculateExtent(this.map.getSize());
            /** @type {?} */
            let extGeometry = fromExtent(extent);
            /** @type {?} */
            let coords = extGeometry.getCoordinates();
            coords = coords[0];
            /** @type {?} */
            let coordsLatLon = [];
            coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[0]);
            coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[1]);
            coordsLatLon.push(toLonLat([coords[1][0], coords[1][1]])[0]);
            coordsLatLon.push(toLonLat([coords[1][0], coords[1][1]])[1]);
            coordsLatLon.push(toLonLat([coords[2][0], coords[2][1]])[0]);
            coordsLatLon.push(toLonLat([coords[2][0], coords[2][1]])[1]);
            coordsLatLon.push(toLonLat([coords[3][0], coords[3][1]])[0]);
            coordsLatLon.push(toLonLat([coords[3][0], coords[3][1]])[1]);
            coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[0]);
            coordsLatLon.push(toLonLat([coords[0][0], coords[0][1]])[1]);
            console.log(coordsLatLon);
            this.busquedaGeo(coordsLatLon, 'Polygon', 5, extent);
            this.consultarV2();
            return true;
        }
        console.log("INFORMACION A BUSCAR>>>>", this.infoBusquedas);
        // document.getElementById('Cbox1')['checked']=false;
        this.figurasActivas = [];
        this.infoBusquedas.forEach((/**
         * @param {?} param
         * @return {?}
         */
        param => {
            console.log(this.infoBusquedas);
            console.log("INFOBUSQUEDAS>>>>", param);
            this.busquedaGeo(param.coords, param.type, param.distance, param.extent);
            this.consultarV2();
        }));
    }
    /**
     * @param {?} status
     * @return {?}
     */
    cambiarMapaCalor(status) {
        //buscar que capa esta encendida, si esta prendida google maps
        // let strokeProp = new Stroke({ color: 'black', width: 2 });
        // let goldFill = new Fill({ color: 'blue' });
        // let styleCache = {};
        // if(status==true){
        //   this.busquedaFacetLayer.setVisible(false);
        //   this.mapaCalor.setVisible(true);
        //   console.log("entro a status truue");
        //  let style = (feature, resolution) =>
        //   {	
        //     let size = feature.get('features').length;
        //     let style;
        //     if(size>1){
        //       let color = size>25 ? "192,0,0" : size>8 ? "255,128,0" : "0,128,0";
        //         let radius = Math.max(8, Math.min(size*0.75, 20));
        //         let dash1 = 2*Math.PI*radius/6;
        //         let dash2 = [ 0, dash1, dash1, dash1, dash1, dash1, dash1 ];
        //         style = styleCache[size] = new Style(
        //           {	image: new CircleStyle(
        //             {	radius: radius,
        //               stroke: new Stroke(
        //                 {	color: "rgba("+color+",0.5)", 
        //                 width: 15 ,
        //                 lineDash: dash2,
        //                 lineCap: "butt"
        //               }),
        //               fill: new Fill(
        //                 {	color:"rgba("+color+",1)"
        //               })
        //             }),
        //             text: new Text(
        //             {	text: size.toString(),
        //               fill: new Fill(
        //                 {	color: '#fff'
        //               })
        //             })
        //           });
        //           return [style];
        //       }
        //     else{
        //       try{
        //         let feat = feature.get('features');
        //         let src=feat[0].getStyle().getImage().getSrc();
        //         let style=feat[0].getStyle();
        //         if (!styleCache[src]) {
        //           styleCache[src] =style;
        //           }
        //           return styleCache[src];
        //         }
        //         catch{
        //           let style = new Style({
        //             image: new RegularShape({
        //               fill: goldFill,
        //               stroke: strokeProp,
        //               points: 4,
        //               radius: 10,
        //               angle: Math.PI / 4
        //             }),
        //             text: new Text({
        //               text: "1",
        //               fill: new Fill({
        //                 color: '#fff'
        //               })
        //             })
        //           });
        //           return style;
        //         }
        //       }
        //   }
        //   this.busquedasActuales.forEach(busqueda=>{
        //     busqueda.cluster.setStyle(style);
        //   })
        // }
        // else{
        //   let style  =  (feature, resolution)=>
        //     {	let size = feature.get('features').length;
        //     if(size>1){
        //       // console.log("Esta inactivo");
        //       let size;
        //       if (!feature || feature.get('features') === undefined) { size = 0 }
        //       else { size = feature.get('features').length }
        //       let style = styleCache[size];
        //       if (!style) {
        //         style = new Style({
        //           image: new RegularShape({
        //             fill: goldFill,
        //             stroke: strokeProp,
        //             points: 4,
        //             radius: 10,
        //             angle: Math.PI / 4
        //           }),
        //           text: new Text({
        //             text: size.toString(),
        //             fill: new Fill({
        //               color: '#fff'
        //             })
        //           })
        //         });
        //         styleCache[size] = style;
        //       }
        //       return style;
        //     }
        //     else{
        //       try{
        //         let feat = feature.get('features');
        //         let src=feat[0].getStyle().getImage().getSrc();
        //         let style=feat[0].getStyle();
        //         if (!styleCache[src]) {
        //           styleCache[src] =style;
        //           }
        //           return styleCache[src];
        //         }
        //         catch{
        //           let style = new Style({
        //             image: new RegularShape({
        //               fill: goldFill,
        //               stroke: strokeProp,
        //               points: 4,
        //               radius: 10,
        //               angle: Math.PI / 4
        //             }),
        //             text: new Text({
        //               text: "1",
        //               fill: new Fill({
        //                 color: '#fff'
        //               })
        //             })
        //           });
        //           return style;
        //         }
        //       }
        //   }
        //   this.busquedasActuales.forEach(busqueda=>{
        //     busqueda.cluster.setStyle(style);
        //   })
        // }
    }
    /**
     * @param {?} p1
     * @param {?} p2
     * @return {?}
     */
    calcularPuntoMedio(p1, p2) {
        /** @type {?} */
        let x1 = p1[0];
        /** @type {?} */
        let y1 = p1[1];
        /** @type {?} */
        let x2 = p2[0];
        /** @type {?} */
        let y2 = p2[1];
        /** @type {?} */
        let x3;
        /** @type {?} */
        let y3;
        x3 = (x1 + x2) / 2;
        y3 = (y1 + y2) / 2;
        return [x3, y3];
    }
    /**
     * @return {?}
     */
    buscarEnFiguraSeleccionada() {
        this.ocultarClickDerechoMenu();
        if (this.selectedFeatures['array_'][0]) {
            /** @type {?} */
            let ObjGeo = this.selectedFeatures['array_'][0].getGeometry();
            // let Coords:Array<number> =
            /** @type {?} */
            let CoordsLonlat = [];
            /** @type {?} */
            let coordss = ObjGeo.getCoordinates();
            coordss[0].forEach((/**
             * @param {?} coords
             * @return {?}
             */
            coords => {
                /** @type {?} */
                let lonLat = toLonLat(coords);
                CoordsLonlat.push(lonLat[0]);
                CoordsLonlat.push(lonLat[1]);
            }));
            console.log("Objeto Geo", ObjGeo);
            /** @type {?} */
            let extent = createEmpty();
            if (ObjGeo) {
                extend(extent, ObjGeo.getExtent());
                this.map.getView().fit(extent);
            }
            this.busquedaGeo(CoordsLonlat, "Polygon", 5, ObjGeo.getExtent());
            this.consultarV2();
        }
    }
    /**
     * @param {?} boolOnOff
     * @param {?} input
     * @param {?} map
     * @param {?=} This
     * @return {?}
     */
    InitBusquedaGM(boolOnOff, input, map, This = this) {
        /** @type {?} */
        let mapElement = document.getElementById("map");
        if (boolOnOff) {
            /** @type {?} */
            let _view = this.map.getView();
            console.log(input);
            // console.log(google.maps.places.SearchBox);
            // let places = google.maps.places.Autocomplete;
            /** @type {?} */
            var searchBox = new google.maps.places.SearchBox(input);
            //_gMap.controls[google.maps.ControlPosition.RIGHT_CENTER].push(input);
            // let map = document.getElementById("map");
            // Bias the SearchBox results towards current map's viewport.
            mapElement.addEventListener('bounds_changed', (/**
             * @return {?}
             */
            function () {
                searchBox.setBounds(map.getBounds());
            }));
            /** @type {?} */
            var markers = [];
            // Listen for the event fired when the user selects a prediction and retrieve
            // more details for that place.
            searchBox.addListener('places_changed', (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var places = searchBox.getPlaces();
                if (places.length == 0) {
                    return;
                }
                if (This.featureAnteriorDireccion != undefined) {
                    if (This.source.hasFeature(This.featureAnteriorDireccion)) {
                        This.source.removeFeature(This.featureAnteriorDireccion);
                    }
                }
                // Clear out the old markers.
                markers.forEach((/**
                 * @param {?} marker
                 * @return {?}
                 */
                function (marker) {
                    marker.setMap(null);
                }));
                markers = [];
                // For each place, get the icon, name and location.
                /** @type {?} */
                var bounds = new google.maps.LatLngBounds();
                places.forEach((/**
                 * @param {?} place
                 * @return {?}
                 */
                function (place) {
                    if (!place.geometry) {
                        console.log("Returned place contains no geometry");
                        return;
                    }
                    /** @type {?} */
                    var icon = {
                        url: place.icon,
                        size: new google.maps.Size(71, 71),
                        origin: new google.maps.Point(0, 0),
                        anchor: new google.maps.Point(17, 34),
                        scaledSize: new google.maps.Size(25, 25)
                    };
                    // console.log("Tiipos", place.types)
                    map.getView().setCenter(fromLonLat([place.geometry.location.lng(), place.geometry.location.lat()]));
                    map.getView().setZoom(13);
                    // map.getView().setZoom();
                    // Create a marker for each place.
                    markers.push(new google.maps.Marker({
                        map: map,
                        icon: icon,
                        title: place.name,
                        position: place.geometry.location
                    }));
                    /** @type {?} */
                    let style = new Style({
                        image: new Icon({
                            anchor: [0.5, 0.5],
                            anchorXUnits: IconAnchorUnits.FRACTION,
                            anchorYUnits: IconAnchorUnits.FRACTION,
                            crossOrigin: 'anonymous',
                            src: "https://cdn3.iconfinder.com/data/icons/shopping-and-market/512/pin_marker_location_mark_navigation_flat_icon-512.png",
                            scale: 0.1
                        })
                    });
                    /** @type {?} */
                    let feature = new Feature({
                        geometry: new Point(fromLonLat([place.geometry.location.lng(), place.geometry.location.lat()]))
                    });
                    feature.setStyle(style);
                    This.featureAnteriorDireccion = feature;
                    This.source.addFeature(feature);
                    console.log("Marcadores", markers);
                    if (place.geometry.viewport) {
                        // Only geocodes have viewport.
                        bounds.union(place.geometry.viewport);
                    }
                    else {
                        bounds.extend(place.geometry.location);
                    }
                }));
                //_gMap.fitBounds(bounds);
                console.log(bounds);
                /** @type {?} */
                var extent = [bounds['ga']['j'], bounds['na']['j'], bounds['ga']['l'], bounds['na']['l']];
                console.log([bounds['ga']['j'], bounds['na']['j'], bounds['ga']['l'], bounds['na']['l']]);
                // var centerBBOX = getCenter(extent);
                // _view.setCenter(transform(centerBBOX, 'EPSG:4326', 'EPSG:3857'));
                // if (places.length <= 1) {
                //     _view.setZoom(16);
                // } else {
                /** @type {?} */
                var extentResolution = _view.getResolutionForExtent(transformExtent(extent, 'EPSG:4326', 'EPSG:3857'));
                /** @type {?} */
                var zoom = _view.getZoomForResolution(extentResolution);
                console.log(zoom);
                _view.setZoom(Math.floor(zoom));
                // }
            }));
        }
        else {
            google.maps.event.clearListeners(mapElement, "bounds_changed");
            google.maps.event.clearListeners(mapElement, "places_changed");
            google.maps.event.clearInstanceListeners(input);
        }
    }
    /**
     * @param {?} header
     * @param {?} feature
     * @param {?=} This
     * @return {?}
     */
    llenarPopUp(header, feature, This = this) {
        console.log(header);
        /** @type {?} */
        let contents;
        this.content.innerHTML += `<div class="card bg-light mb-3">`;
        this.content.innerHTML += `<div class="card-header">${header}</div>`;
        this.content.innerHTML += `<div class="card-body">`;
        /** @type {?} */
        let arrayValues;
        /** @type {?} */
        let arrayKeys;
        try {
            contents = feature.values_.content;
            contents.forEach((/**
             * @param {?} contenido
             * @return {?}
             */
            contenido => {
                this.content.innerHTML += `<p class="card-text">${contenido.titulo}: ${contenido.valor}</p>`;
            }));
        }
        catch (_a) {
            console.log("Cuidado", " el contenido no es un arreglo de contenido");
            try {
                console.log("Intentando convertir un objeto de objetos a arreglo de contenido");
                arrayValues = Object.values(feature.values_.content);
                arrayKeys = Object.keys(feature.values_.content);
                /** @type {?} */
                let newContent = [];
                for (let index = 0; index < arrayValues.length; index++) {
                    newContent.push({ titulo: arrayKeys[index], valor: arrayValues[index] });
                }
                feature.values_.content = newContent;
                contents = newContent;
                contents.forEach((/**
                 * @param {?} contenido
                 * @return {?}
                 */
                contenido => {
                    this.content.innerHTML += `<p class="card-text">${contenido.titulo}: ${contenido.valor}</p>`;
                }));
            }
            catch (_b) {
                console.log("ArrayKeys", arrayKeys);
                console.log("ArrayValues", arrayValues);
                console.log("contenido", contents);
                console.log("Falló, corregir el contenido");
            }
        }
        console.log("ArrayKeys", arrayKeys);
        console.log("ArrayValues", arrayValues);
        console.log("contenido", contents);
        this.content.innerHTML += `<div class="card bg-light mb-3">`;
        this.content.innerHTML += `</div></div>`;
        // featuresData.push(feature['values_'].data);
    }
    /*
      Metodo para relizar  una busqueda por texto a traves del input.
      */
    /**
     * @param {?} fuente
     * @return {?}
     */
    seleccionarBusqueda(fuente) {
        console.log("Busquedas texto", this.busquedasTexto);
        if (fuente == "Google maps") {
            this.InitBusquedaGM(true, this.direccionesElement.nativeElement, this.map);
            this.busquedaTextoActual = null;
            this.showOption = false;
            this.inputPlaceholder = "Direcciones";
            return;
        }
        else {
            this.InitBusquedaGM(false, this.direccionesElement.nativeElement, this.map);
        }
        this.busquedasActuales2.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            if (fuente != item.titulo) {
                if (item.visible == true) {
                    this.cambiarStatusBusqueda(item.titulo);
                }
            }
            else {
                if (item.visible == false) {
                    this.cambiarStatusBusqueda(item.titulo);
                }
            }
        }));
        this.busquedasTexto.find((/**
         * @param {?} busquedaTexto
         * @return {?}
         */
        busquedaTexto => {
            if (busquedaTexto.nombre == fuente) {
                this.inputPlaceholder = busquedaTexto.placeholder;
                this.busquedaTextoActual = busquedaTexto;
                // this.busquedaPorOrigen(busquedaTexto.nombre);
                //Hacer busqueda textual
                return true;
            }
        }));
        this.showOption = false;
        if (this.direccionesElement.nativeElement.value != "") {
            this.busquedaPorTexto();
        }
        else {
            this.labelActualizar.nativeElement.style.display = "block";
            this.buscando = true;
            if (this.source.getFeatures().length == 0) {
                /** @type {?} */
                let timerInterval;
                swal.fire({
                    title: 'Buscando...',
                    html: `Iniciando busqueda por \"${fuente}\"`,
                    timer: 15000,
                    timerProgressBar: true,
                    onBeforeOpen: (/**
                     * @return {?}
                     */
                    () => {
                        swal.showLoading();
                    }),
                    onClose: (/**
                     * @return {?}
                     */
                    () => {
                        clearInterval(timerInterval);
                    })
                }).then((/**
                 * @param {?} result
                 * @return {?}
                 */
                (result) => {
                    if (
                    /* Read more about swal dismissals below */
                    result.dismiss === swal.DismissReason.timer) {
                        console.log('I was closed by the timer'); // eslint-disable-line
                    }
                }));
                this.figurasActivas = [];
                this.generarFiguraVentana();
                this.vaciarCajaResultados();
                this.consultarV2().then((/**
                 * @param {?} resolve
                 * @return {?}
                 */
                resolve => {
                    swal.close();
                }));
            }
            else {
                this.figurasActivas = [];
                this.infoBusquedas.forEach((/**
                 * @param {?} param
                 * @return {?}
                 */
                param => {
                    console.log(this.infoBusquedas);
                    console.log("INFOBUSQUEDAS>>>>", param);
                    this.busquedaGeo(param.coords, param.type, param.distance, param.extent);
                    this.consultarV2();
                }));
            }
        }
    }
    /**
     * @return {?}
     */
    busquedaPorTexto() {
        // collapse()
        /*
          Si busquedaTextoActual es nulo, quiere decir que esta buscando por googlemaps
        */
        if (this.direccionesElement.nativeElement.value == "") {
            console.log("Error", "Input de busquedas vacio");
            return;
        }
        if (this.showOption)
            this.showOption = false;
        if (this.busquedaTextoActual) {
            /** @type {?} */
            let nombre;
            /** @type {?} */
            let url;
            /** @type {?} */
            let texto;
            /** @type {?} */
            let campo;
            if (this.filtroConcat) {
                if (this.filtroConcat.length > 1)
                    nombre = this.busquedaTextoActual.nombre + ";" + this.filtroConcat.slice(0, this.filtroConcat.length - 1);
                else
                    nombre = this.busquedaTextoActual.nombre;
            }
            else
                nombre = this.busquedaTextoActual.nombre;
            url = this.confBusquedaText.URL;
            campo = this.busquedaTextoActual.campo; //filtros
            texto = this.direccionesElement.nativeElement.value;
            /** @type {?} */
            let params = {
                texto: texto,
                tipo: nombre,
                //Origen
                campo: campo
            };
            console.log("URL>>>>>><<", url);
            console.log("params>>>>>><<", params);
            this.http.post(url, params).subscribe((/**
             * @param {?} data
             * @return {?}
             */
            (data) => {
                if (data.length == 0 || data == null || data == undefined) {
                    swal.fire('Ooops', 'No se encontraron resultados en esta area', 'info');
                }
                else {
                    this.resultadoPorBusquedaTextoAsync(nombre, data);
                }
            }));
        }
    }
    /**
     * @param {?} nombre
     * @param {?} dataResponse
     * @return {?}
     */
    resultadoPorBusquedaTextoAsync(nombre, dataResponse) {
        this.busquedaClusterLayer.getSource().getSource().clear();
        this.busquedaFacetLayer.getSource().clear();
        /** @type {?} */
        let found;
        /** @type {?} */
        let layer;
        console.log("Busquedas actuales", this.busquedasActuales);
        console.log("Capas actuales", this.capasActuales);
        //Buscar en los objetos capa primero.
        this.capasActuales.find((/**
         * @param {?} capa
         * @return {?}
         */
        capa => {
            if (capa.nombre == nombre) {
                layer = capa.layer;
                found = true;
                return true;
            }
        }));
        if (!found) {
            this.busquedaTextoLayer.getSource().getSource().clear();
            layer = this.busquedaTextoLayer;
        }
        console.log("Respuesta Busqueda texto: ", dataResponse);
        // Modelo Respuesta Universal
        // let parserWKT =  new io.WKTReader();
        // let parserOL3 =  new io.OL3Parser();
        // parserOL3.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
        /*
        {
          objWKT = Point(x y)
          Icon = http://localhost/icon.jpg
        }*/
        dataResponse.forEach((/**
         * @param {?} respuesta
         * @return {?}
         */
        respuesta => {
            if (layer.getVisible() == false) {
                layer.setVisible(true);
            }
            // let geoWKT:string =respuesta.geometry;
            // let geoOL3 = parserOL3.write(parserWKT.read(geoWKT.toUpperCase()));
            /** @type {?} */
            let format = new WKT();
            /** @type {?} */
            let feature = format.readFeature(respuesta.geometry, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
            // feature.setProperties({icon:respuesta.icon});
            if (respuesta.icon != undefined && respuesta.icon != "") {
                /** @type {?} */
                let iconStyle = new Style({
                    image: new Icon({
                        anchor: [0.5, 20],
                        anchorXUnits: IconAnchorUnits.FRACTION,
                        anchorYUnits: IconAnchorUnits.PIXELS,
                        crossOrigin: 'anonymous',
                        src: respuesta.icon,
                        scale: 0.8
                    })
                });
                feature.setStyle(iconStyle);
            }
            // feature.setProperties({urlDetalle:this.confBusquedaGeo.URLDetalle});
            feature.setProperties({ UUID: respuesta.UUID });
            feature.setProperties({ total: respuesta.total });
            // console.log("Geometria resultante de la busqueda por texto",feature.getGeometry());
            //Convertir lat lon a x y
            // console.log("Feature resultante de la busqueda por texto",feature);
            layer.getSource().getSource().addFeature(feature);
        }));
    }
    /**
     * @return {?}
     */
    openNav() {
        document.getElementsByClassName("ol-zoom").item(0).setAttribute("style", "margin-left:30%;transition: 0.5s;");
        console.log("filtrosGlobales>>>", this.filtrosGlobales);
        document.getElementById("mySidepanel").style.width = "30%";
        document.getElementById("openbtn").style.display = "none";
        document.getElementById("openBtnMas").style.display = "block";
    }
    /**
     * @return {?}
     */
    openNavMas() {
        document.getElementById("openBtnMas").style.display = "none";
        document.getElementById("mySidepanel").style.width = "100%";
    }
    /**
     * @return {?}
     */
    closeNav() {
        document.getElementsByClassName("ol-zoom").item(0).setAttribute("style", "margin-left:0px;transition: 0.5s;");
        document.getElementById("openBtnMas").style.display = "none";
        this.isCollapsedR = true;
        document.getElementById("mySidepanel").style.width = "0";
        document.getElementById("openbtn").style.display = "block";
        this.buscarArea.nativeElement.style.display = `none`;
        this.vaciarCajaResultados();
    }
    /**
     * @return {?}
     */
    ocultarClickDerechoMenu() {
        this.menuElement.nativeElement.style.display = `none`;
    }
    /**
     * @return {?}
     */
    clickDerechoMenu() {
        /** @type {?} */
        const toggleMenu = (/**
         * @param {?} command
         * @return {?}
         */
        command => {
            this.menuElement.nativeElement.style.display = command === "show" ? "block" : "none";
        });
        /** @type {?} */
        const setPosition = (/**
         * @param {?} __0
         * @return {?}
         */
        ({ top, left }) => {
            this.menuElement.nativeElement.style.left = `${left}px`;
            this.menuElement.nativeElement.style.top = `${top}px`;
            toggleMenu('show');
        });
        window.addEventListener("contextmenu", (/**
         * @param {?} e
         * @return {?}
         */
        e => {
            e.preventDefault();
            /** @type {?} */
            const origin = {
                left: e.pageX,
                top: e.pageY
            };
            setPosition(origin);
            return false;
        }));
    }
    /**
     * @param {?} This
     * @return {?}
     */
    InicializarEventoViewChange(This) {
        this.view.on('change', (/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            console.log('evento =>', event);
            This.viewChanged.next(event);
        }));
    }
    /**
     * @return {?}
     */
    consultarV2() {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => {
            /** @type {?} */
            let capa;
            /** @type {?} */
            let TipoResultado = "";
            this.infoDetTitulo = [];
            this.infoDetalle = [];
            //Get values
            this.infoDetValues = [];
            this.infoTitulos = [];
            this.infoDetBotones = [];
            console.log(this.view.getZoom());
            // Buscar que capa prender,tipo de resultado que se necesite y layer en el cual se le insertará datos 
            if (this.view.getZoom() < 15) {
                this.busquedaClusterLayer.setVisible(false);
                if (this.statusMapaCalor) {
                    this.mapaCalor.setVisible(true);
                    this.busquedaFacetLayer.setVisible(false);
                    TipoResultado = "HeatMap";
                    // this.mapaCalor.setRadius(70-this.view.getZoom());
                }
                else {
                    TipoResultado = "Facet";
                    this.busquedaFacetLayer.setVisible(true);
                    this.mapaCalor.setVisible(false);
                }
                capa = this.busquedaFacetLayer;
            }
            else {
                this.spinner.show();
                this.busquedaClusterLayer.setVisible(true);
                this.busquedaFacetLayer.setVisible(false);
                this.mapaCalor.setVisible(false);
                //   // if(this.busquedaAnterior!=this.figurasActivas){
                TipoResultado = "Resultado";
                capa = this.busquedaClusterLayer;
                //     this.pedirdatosResult=true;
                //     this.busquedaAnterior=this.figurasActivas;
            }
            //   // else{
            //     // console.log("Ya  se  obtuvieron esos datos.");
            //     // return ;
            //   // }
            // }
            // Concatenar los tipos de origenes.
            /** @type {?} */
            let tiposOrigen = "";
            this.tiposOrigenes.forEach((/**
             * @param {?} tipo
             * @return {?}
             */
            tipo => {
                if (tipo != null) {
                    tiposOrigen += `tipoOrigen=${tipo};`;
                }
            }));
            tiposOrigen = tiposOrigen.slice(0, tiposOrigen.length - 1);
            /** @type {?} */
            let ext = this.map.getView().calculateExtent(this.map.getSize());
            /** @type {?} */
            let minXYLonLat = toLonLat([ext[0], ext[1]]);
            /** @type {?} */
            let maxXYLonLat = toLonLat([ext[2], ext[3]]);
            /** @type {?} */
            let extWKTVentana = `[${minXYLonLat[0]} ${minXYLonLat[1]} TO ${maxXYLonLat[0]} ${maxXYLonLat[1]}]`;
            if (this.figurasActivas.length == 0) {
                console.log('No se encontro alguna figura para buscar');
                this.spinner.hide();
                return;
            }
            else
                this.busquedaTextoLayer.getSource().getSource().clear();
            /** @type {?} */
            let filtrosGenerales = "";
            if (this.filtroConcat) {
                filtrosGenerales += this.filtroConcat;
            }
            this.filtrosGlobales.forEach((/**
             * @param {?} filtro
             * @return {?}
             */
            filtro => {
                /** @type {?} */
                let valueDate = "";
                if (filtro.type == "range_date") {
                    if (filtro.valueFormat.startDate == null || filtro.valueFormat.endDate == null) {
                        return true;
                    }
                    else {
                        /** @type {?} */
                        let date1;
                        /** @type {?} */
                        let date2;
                        date1 = filtro.valueFormat.startDate.toDate();
                        /** @type {?} */
                        let day1 = date1.getDay().length == 1 ? date1.getDay() : `0${date1.getDay()}`;
                        /** @type {?} */
                        let month1 = date1.getMonth().length == 1 ? date1.getMonth() : `0${date1.getMonth()}`;
                        date2 = filtro.valueFormat.endDate.toDate();
                        /** @type {?} */
                        let day2 = date2.getDay().length == 1 ? date2.getDay() : `0${date2.getDay()}`;
                        /** @type {?} */
                        let month2 = date2.getMonth().length == 1 ? `0${date2.getMonth()}` : date2.getMonth();
                        valueDate = `[${date1.getFullYear()}-${month1}-${day1}T00:00:00Z TO ${date2.getFullYear()}-${month2}-${day2}T23:59:59Z]`;
                        filtrosGenerales += `${filtro.name}=${valueDate};`;
                    }
                }
                else {
                    filtrosGenerales += `${filtro.name}=${filtro.valueFormat};`;
                }
            }));
            filtrosGenerales = filtrosGenerales.slice(0, filtrosGenerales.length - 1);
            console.log('Filtros generales', filtrosGenerales);
            /** @type {?} */
            let tipo = TipoResultado;
            if (tipo == "Resultado")
                tipo = 'Facet';
            /** @type {?} */
            let param = {
                ExtWKT: extWKTVentana,
                GeometryWKT: this.figurasActivas,
                TipoResultado: tipo,
                TipoOrigen: tiposOrigen,
                Filtros: filtrosGenerales,
                Zoom: this.map.getView().getZoom()
            };
            console.log("Parametros", param);
            // let URL = _url;
            /** @type {?} */
            let URL = this.confBusquedaGeo.URLbusqueda;
            this.http.post(URL, param, { headers: new HttpHeaders({ 'Content-Type': 'application/json' }) }).subscribe((/**
             * @param {?} data
             * @return {?}
             */
            (data) => {
                if (data.length == 0 || data == null || data == undefined) {
                    resolve(false);
                    swal.fire('Ooops', 'No se encontraron resultados en esta area', 'info');
                    this.spinner.hide();
                    // swal('Info', 'No se encontraron resultados', 'info');
                    // this.figurasActivas=[];
                }
                else {
                    switch (TipoResultado) {
                        case "Facet":
                            capa.getSource().clear(true);
                            break;
                        case "HeatMap":
                            this.mapaCalor.getSource().clear(true);
                            console.log("Se limpio el mapa de calor");
                            break;
                        default:
                            capa.getSource().getSource().clear(true);
                            break;
                    }
                    resolve(true);
                    //contar tiempo de aca
                    this.agregarFeatureExperimental(data, capa, TipoResultado);
                    // a aca
                    //si es mas de 2 segundos mostrar spinner
                    this.spinner.hide();
                    console.log("ResponseData=>", data);
                }
            }));
        }));
    }
    /**
     * @param {?} data
     * @param {?} layer
     * @param {?} tipo
     * @return {?}
     */
    agregarFeatureExperimental(data, layer, tipo) {
        // data.forEach(feature => {
        //   let fture= new Feature({
        //     geometry:new Point(fromLonLat(feature.Coordenadas)),
        //     texto:feature.Detalle.texto
        //   })fd
        console.log("Datos busqueda geo", data);
        // let geoJsonFormat = new GeoJson();
        // let features = geoJsonFormat.readFeatures(data, {featureProjection: 'EPSG:3857',dataProjection:'EPSG:4326'});
        data.forEach((/**
         * @param {?} respuesta
         * @return {?}
         */
        respuesta => {
            console.log(respuesta);
            // if(layer.getVisible()==false){
            //   layer.setVisible(true);
            // }
            // let geoWKT:string =respuesta.geometry;
            // let geoOL3 = parserOL3.write(parserWKT.read(geoWKT.toUpperCase()));
            /** @type {?} */
            let format = new WKT();
            /** @type {?} */
            let feature;
            if (tipo == 'HeatMap') {
                feature = format.readFeature(respuesta.polygon, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
                /** @type {?} */
                let total = respuesta.total;
                /** @type {?} */
                let color = "0,128,0";
                /** @type {?} */
                let weight = respuesta.total > 25 ? 1 : respuesta.total > 8 ? 0.7 : 0.4;
                if (total == null || total == undefined)
                    color = "0,128,0";
                // let color =>25 ? "192,0,0" : feature.get('total')>8 ? "255,128,0" : "0,128,0";
                /** @type {?} */
                let polygonStyle = new Style({
                    stroke: new Stroke({
                        color: `rgba(${color}, 0.5)`,
                        width: 3
                    }),
                    fill: new Fill({
                        color: `rgba(${color}, ${weight})`
                    })
                });
                feature.setStyle(polygonStyle);
                console.log(total, color);
            }
            else
                feature = format.readFeature(respuesta.geometry, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
            if (respuesta.total == "1" && respuesta.icon != null) {
                //Si no es heatmap se pone el estilo
                if (tipo != "HeatMap") {
                    /** @type {?} */
                    let iconStyle = new Style({
                        image: new Icon({
                            anchor: [0.5, 20],
                            anchorXUnits: IconAnchorUnits.FRACTION,
                            anchorYUnits: IconAnchorUnits.PIXELS,
                            crossOrigin: 'anonymous',
                            src: respuesta.icon,
                            scale: 0.8
                        })
                    });
                    feature.setStyle(iconStyle);
                }
            }
            // feature.setProperties({urlDetalle:this.confBusquedaGeo.URLDetalle});
            feature.setProperties({ UUID: respuesta.UUID });
            feature.setProperties({ polygon: respuesta.polygon });
            feature.setProperties({ total: respuesta.total });
            feature.setProperties({ weight: respuesta.total });
            // console.log("Geometria resultante de la busqueda por texto",feature.getGeometry());
            //Convertir lat lon a x y
            // console.log("Feature resultante de la busqueda por texto",feature);
            if (tipo == 'Resultado') {
                // feature.setId(respuesta.UUID);
                layer.getSource().getSource().addFeature(feature);
            }
            else if (tipo == 'Facet') {
                layer.getSource().addFeature(feature);
                // layer.getSource().getSource().addFeature(feature);
            }
            else if (tipo == "HeatMap") {
                this.mapaCalor.getSource().addFeature(feature);
                console.log(feature);
            }
        }));
        // console.log(layer.getSource());
        // let source = layer.getSource();
        // source.addFeature(fture);
        // });
    }
    /**
     * @param {?} titulo
     * @return {?}
     */
    cambiarStatusBusqueda(titulo) {
        console.log("AASD");
        this.busquedasActuales2.find((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            if (titulo == item.titulo) {
                if (item.visible == true) {
                    this.tiposOrigenes[this.tiposOrigenes.indexOf(item.nombre)] = null;
                    item.visible = false;
                    this.confBusquedaGeo.filtros.forEach((/**
                     * @param {?} filtro
                     * @return {?}
                     */
                    filtro => {
                        if (filtro.origen == item.nombre) {
                            /** @type {?} */
                            let obj = new Filter();
                            obj.name = filtro.nombre;
                            obj.title = filtro.titulo;
                            obj.type = filtro.tipo; //date, text, select
                            obj.valueFormat = filtro.valordefault; //date, text, select
                            this.filtrosGlobales.splice(this.filtrosGlobales.indexOf(obj), 1);
                        }
                    }));
                }
                else {
                    this.confBusquedaGeo.filtros.forEach((/**
                     * @param {?} filtro
                     * @return {?}
                     */
                    filtro => {
                        if (filtro.origen == item.nombre) {
                            /** @type {?} */
                            let obj = new Filter();
                            obj.name = filtro.nombre;
                            obj.title = filtro.titulo;
                            obj.type = filtro.tipo; //date, text, select
                            obj.valueFormat = filtro.valordefault; //date, text, select
                            this.filtrosGlobales.push(obj);
                        }
                    }));
                    item.visible = true;
                    this.tiposOrigenes.push(item.nombre);
                }
                return true;
            }
        }));
    }
    /**
     * @return {?}
     */
    buscarDetalle() {
        /** @type {?} */
        let param = {
            GeometrysWKT: this.paginacionGeo.geometrysWKT,
            TipoOrigen: this.paginacionGeo.tipoOrigen,
            PagActual: this.paginacionGeo.pagActual,
            RPP: this.paginacionGeo.RPP,
            UUID: this.paginacionGeo.UUID
        };
        console.log("Parametros de busqueda click", param);
        /** @type {?} */
        let URL = this.confBusquedaGeo.URLDetalle;
        this.http.post(URL, param, { headers: new HttpHeaders({ 'Content-Type': 'application/json' }) }).subscribe((/**
         * @param {?} data
         * @return {?}
         */
        (data) => {
            this.infoDetalle = data;
            this.infoDetTitulo = [];
            this.infoDetValues = [];
            this.infoTitulos = [];
            this.infoDetBotones = [];
            //Limpiar nulos
            // this.confResultadosVista.Estructura  
            this.infoDetalle.forEach((/**
             * @param {?} element
             * @return {?}
             */
            element => {
            }));
            /** @type {?} */
            let objVistaTmp;
            /** @type {?} */
            let objetoTmp = {};
            this.infoDetalle.forEach((/**
             * @param {?} element
             * @return {?}
             */
            element => {
                switch (element.TipoOrigen) {
                    case "Bts":
                        objetoTmp = element;
                        //Revisar JSON
                        if (this.confResultadosVista.Bts.CampoEspeciales != undefined) {
                            if (this.confResultadosVista.Bts.CampoEspeciales.JSON != undefined && this.confResultadosVista.Bts.CampoEspeciales.JSON.length > 0) {
                                this.confResultadosVista.Bts.CampoEspeciales.JSON.forEach((/**
                                 * @param {?} element
                                 * @return {?}
                                 */
                                element => {
                                    /** @type {?} */
                                    let objJSON = JSON.parse(objetoTmp[element]);
                                    objetoTmp = Object.assign(objetoTmp, objJSON);
                                }));
                            }
                            //Revisar Fecha
                            if (this.confResultadosVista.Bts.CampoEspeciales.fecha != undefined && this.confResultadosVista.Bts.CampoEspeciales.fecha.length > 0) {
                                this.confResultadosVista.Bts.CampoEspeciales.fecha.forEach((/**
                                 * @param {?} element
                                 * @return {?}
                                 */
                                element => {
                                    objetoTmp[element] = this.obtenerFechaFormateada(objetoTmp[element], 1);
                                }));
                            }
                        }
                        objVistaTmp = {};
                        this.confResultadosVista.Bts.Vista.forEach((/**
                         * @param {?} element
                         * @return {?}
                         */
                        element => {
                            objVistaTmp[element] = objetoTmp[element];
                        }));
                        if (this.confResultadosVista.Bts.botones != undefined) {
                            /** @type {?} */
                            let tmpBotones = [];
                            this.confResultadosVista.Bts.botones.forEach((/**
                             * @param {?} boton
                             * @return {?}
                             */
                            boton => {
                                tmpBotones.push({ clase: boton.clase, accion: boton.accion, contenido: boton.contenido, tipo: boton.tipo });
                                // `<button type="button" class="${boton.clase}" (click)="clickDetExt(${element},${boton.accion})" >${boton.contenido}</button>`
                                //  
                            }));
                            this.infoDetBotones.push(tmpBotones);
                            console.log("Botones", tmpBotones);
                        }
                        break;
                    case "Chat":
                        objetoTmp = element;
                        //Revisar JSON
                        if (this.confResultadosVista.Chat.CampoEspeciales != undefined) {
                            if (this.confResultadosVista.Chat.CampoEspeciales.JSON != undefined && this.confResultadosVista.Chat.CampoEspeciales.JSON.length > 0) {
                                this.confResultadosVista.Chat.CampoEspeciales.JSON.forEach((/**
                                 * @param {?} element
                                 * @return {?}
                                 */
                                element => {
                                    /** @type {?} */
                                    let objJSON = JSON.parse(objetoTmp[element]);
                                    objetoTmp = Object.assign(objetoTmp, objJSON);
                                }));
                            }
                            //Revisar Fecha
                            if (this.confResultadosVista.Chat.CampoEspeciales.fecha != undefined && this.confResultadosVista.Chat.CampoEspeciales.fecha.length > 0) {
                                this.confResultadosVista.Chat.CampoEspeciales.fecha.forEach((/**
                                 * @param {?} element
                                 * @return {?}
                                 */
                                element => {
                                    objetoTmp[element] = this.obtenerFechaFormateada(objetoTmp[element], 1);
                                }));
                            }
                        }
                        objVistaTmp = {};
                        this.confResultadosVista.Chat.Vista.forEach((/**
                         * @param {?} element
                         * @return {?}
                         */
                        element => {
                            objVistaTmp[element] = objetoTmp[element];
                        }));
                        if (this.confResultadosVista.Chat.botones != undefined) {
                            /** @type {?} */
                            let tmpBotones = [];
                            this.confResultadosVista.Chat.botones.forEach((/**
                             * @param {?} boton
                             * @return {?}
                             */
                            boton => {
                                tmpBotones.push({ clase: boton.clase, accion: boton.accion, contenido: boton.contenido, tipo: boton.tipo });
                                // `<button type="button" class="${boton.clase}" (click)="clickDetExt(${element},${boton.accion})" >${boton.contenido}</button>`
                                //  
                            }));
                            this.infoDetBotones.push(tmpBotones);
                        }
                        break;
                    case "Nacional":
                        objetoTmp = element;
                        //Revisar JSON
                        if (this.confResultadosVista.Nacional.CampoEspeciales != undefined) {
                            if (this.confResultadosVista.Nacional.CampoEspeciales.JSON != undefined && this.confResultadosVista.Nacional.CampoEspeciales.JSON.length > 0) {
                                this.confResultadosVista.Nacional.CampoEspeciales.JSON.forEach((/**
                                 * @param {?} element
                                 * @return {?}
                                 */
                                element => {
                                    /** @type {?} */
                                    let objJSON = JSON.parse(objetoTmp[element]);
                                    objetoTmp = Object.assign(objetoTmp, objJSON);
                                }));
                            }
                            //Revisar Fecha
                            if (this.confResultadosVista.Nacional.CampoEspeciales.fecha != undefined && this.confResultadosVista.Nacional.CampoEspeciales.fecha.length > 0) {
                                this.confResultadosVista.Nacional.CampoEspeciales.fecha.forEach((/**
                                 * @param {?} element
                                 * @return {?}
                                 */
                                element => {
                                    objetoTmp[element] = this.obtenerFechaFormateada(objetoTmp[element], 1);
                                }));
                            }
                        }
                        objVistaTmp = {};
                        this.confResultadosVista.Nacional.Vista.forEach((/**
                         * @param {?} element
                         * @return {?}
                         */
                        element => {
                            objVistaTmp[element] = objetoTmp[element];
                        }));
                        if (this.confResultadosVista.Nacional.botones != undefined) {
                            /** @type {?} */
                            let tmpBotones = [];
                            this.confResultadosVista.Nacional.botones.forEach((/**
                             * @param {?} boton
                             * @return {?}
                             */
                            boton => {
                                tmpBotones.push({ clase: boton.clase, accion: boton.accion, contenido: boton.contenido, tipo: boton.tipo });
                                // `<button type="button" class="${boton.clase}" (click)="clickDetExt(${element},${boton.accion})" >${boton.contenido}</button>`
                                //  
                            }));
                            this.infoDetBotones.push(tmpBotones);
                        }
                        break;
                    default:
                        break;
                }
                // this.confResultadosVista={
                //   "Chat":{Vista:["Campo1","Campo2","Campo2"],CampoEspeciales:{JSON:['Modelo','Mensaje'],fecha:"FechaCreacion"}},
                //   "Bts":{Vista:["Campo1","Campo2","Campo2"],CampoEspeciales:{JSON:['Modelo','Mensaje'],fecha:"FechaCreacion"}},
                //   "Nacional":{Vista["Campo1","Campo2","Campo2"],CampoEspeciales:{JSON:['Modelo','Mensaje'],fecha:"FechaCreacion"}}
                // }
                this.infoVista.push(objVistaTmp);
                //Get keys
                /** @type {?} */
                let tmpVista = Object.keys(objVistaTmp);
                tmpVista.shift();
                this.infoDetTitulo.push(tmpVista);
                //Get values
                /** @type {?} */
                let tmpValues = Object.values(objVistaTmp);
                tmpValues.shift();
                this.infoDetValues.push(tmpValues);
                try {
                    this.infoTitulos.push(Object.values(objVistaTmp)[0].toString());
                }
                catch (_a) {
                    console.log(objVistaTmp);
                }
                console.log(this.infoTitulos);
            }));
            if (data.length > 0) {
                // if(this.isCollapsedR){
                if (this.isCollapsedR == true) {
                    this.openNav();
                    this.isCollapsedR = false;
                }
                // }
            }
            console.log('info detalle', this.infoDetalle);
            console.log('info Titulo', this.infoDetTitulo);
            console.log('info Values', this.infoDetValues);
            console.log("ResponseDataClick=>", data);
            console.log("Nuevo info detalle sin nulos", this.infoDetalle);
        }));
    }
    /**
     * @return {?}
     */
    detallePaginaSiguiente() {
        if (this.infoDetalle.length == this.paginacionGeo.RPP) {
            this.paginacionGeo.pagActual++;
            this.buscarDetalle();
            document.getElementById('mySidepanel').scrollTo(0, 0);
        }
    }
    /**
     * @return {?}
     */
    detallePaginaAnterior() {
        if (this.paginacionGeo.pagActual != 1) {
            this.paginacionGeo.pagActual--;
            this.buscarDetalle();
            document.getElementById('mySidepanel').scrollTo(0, 0);
        }
    }
    /**
     * @return {?}
     */
    buscarEnFiguraResultados() {
        this.ocultarClickDerechoMenu();
        /** @type {?} */
        let feature = this.selectedFeatures['array_'][0];
        /** @type {?} */
        let polygonWKT;
        if (feature != undefined) {
            /** @type {?} */
            let format = new WKT();
            polygonWKT = format.writeFeature(feature, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
        }
        console.log('Figura seleccionada WKT', polygonWKT);
        this.paginacionGeo.geometrysWKT = [polygonWKT];
        this.paginacionGeo.pagActual = 1;
        this.paginacionGeo.RPP = 10;
        this.paginacionGeo.UUID = null;
        this.buscarDetalle();
        // let param = {
        //   GeometrysWKT: this.paginacionGeo.geometrysWKT,
        //   PagActual:this.paginacionGeo.pagActual,
        //   RPP:this.paginacionGeo.RPP,
        //   UUID:this.paginacionGeo.UUID
        // }
    }
    /**
     * @return {?}
     */
    obtenerConfiguracion() {
        /** @type {?} */
        let URL = this.urlConfiguracion;
        /** @type {?} */
        let param = { App: this.app };
        console.log('Variable app >>>>', this.app);
        console.log('Obteniendo Objeto de configuracion...', URL);
        return this.http.post(URL, param, { headers: new HttpHeaders({ 'Content-Type': 'application/json' }) });
    }
    /**
     * @return {?}
     */
    busquedaInicial() {
        /** @type {?} */
        let tipoYfq;
        /** @type {?} */
        let url;
        /** @type {?} */
        let texto;
        tipoYfq = this.filtroInicial; //TipoOrigen+&+campo:Valor
        url = this.confBusquedaText.URL;
        texto = "Coordenadas:[-90,-180 TO 90,180]";
        /** @type {?} */
        let params = {
            texto: texto,
            tipo: tipoYfq,
            campo: 'Query'
        };
        /** @type {?} */
        let tipo = tipoYfq.split('&')[0];
        console.log("Paramestros>>>>>>>>", params);
        console.log("tipo>>>>>>>>", tipo);
        this.http.post(url, params).subscribe((/**
         * @param {?} data
         * @return {?}
         */
        data => {
            this.resultadoPorBusquedaTextoAsync(tipo, data);
        }));
    }
    /**
     * @return {?}
     */
    busquedaPorArea() {
        if (this.source.getFeatures().length == 0) {
            this.figurasActivas = [];
            this.generarFiguraVentana();
            this.consultarV2();
        }
        else {
            this.infoBusquedas.forEach((/**
             * @param {?} param
             * @return {?}
             */
            param => {
                console.log(this.infoBusquedas);
                console.log("INFOBUSQUEDAS>>>>", param);
                // this.busquedaGeo(param.coords,param.type,param.distance,param.extent);
                this.consultarV2();
            }));
            console.log(this.infoBusquedas);
        }
    }
    /**
     * @return {?}
     */
    vaciarCajaResultados() {
        this.infoDetTitulo = [];
        this.infoDetValues = [];
        this.infoTitulos = [];
        this.infoDetBotones = [];
    }
    /**
     * @param {?} modelo
     * @param {?} accion
     * @return {?}
     */
    clickDetExt(modelo, accion) {
        console.log("Si se hizo carnal");
        this.clicExterno.emit({ modelo: modelo, accion: accion });
    }
    /**
     * @return {?}
     */
    changeShowValue() {
        console.log("Cambiandole el valor al mostrador");
        this.showOption = true;
    }
}
MapaComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngbi-map',
                template: "\n<ngx-spinner bdColor=\"rgba(51,51,51,0.8)\" size=\"medium\" color=\"#fff\" type=\"ball-grid-beat\">\n    <p style=\"font-size: 20px; color: white\">Cargando...</p>\n</ngx-spinner>\n<div>\n   \n  <div class=\"componentMap\">\n      <!-- Menu principal -->\n      <div class=\"btn-group divMenu\">\n        <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Mapas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <button ngbDropdownItem (click)=\"funcionesMenu('OSM')\">Open Street Map</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('Google')\">Google Maps</button>\n            </div>\n          </div>\n          <div *ngIf=\"capasActuales.length>0\" class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Capas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <div *ngFor=\"let capa of capasActuales\" style=\"text-align: -webkit-center;\"  class=\"switcher\">\n                  <input type=\"checkbox\" [id]=\"capa.nombre\" name=\"checkbox\" [(ngModel)]=\"capa.layer.values_.visible\">\n                  <label [for]=\"capa.nombre\" style=\"display: -webkit-inline-box;margin-left: 1rem\" >{{capa.nombre}}</label>\n                </div>\n            </div>\n          </div>\n          <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Busquedas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <div *ngFor=\"let busqueda of busquedasActuales2\" style=\"text-align: -webkit-center;\"  class=\"switcher\">\n                  <input type=\"checkbox\"  name=\"switcher_checkbox_1\" [id]=\"'busqueda'+busqueda.titulo\" checked=\"\" (click)=\"cambiarStatusBusqueda(busqueda.titulo)\" [(ngModel)]=\"busqueda.visible\">\n                  <label [for]=\"'busqueda'+busqueda.titulo\" style=\"display: -webkit-inline-box;margin-left: 1rem\" >{{busqueda.titulo}}</label>\n                </div>\n                  <!-- <button *ngFor=\"let capa of arregloCapas\" (click)=\"modCapa(capa.name)\" ></button> -->\n                </div>\n              </div>\n              <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Geometr\u00EDas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <button ngbDropdownItem (click)=\"funcionesMenu('Polygon')\">Poligono</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('Circle')\">Circulo</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('circleOpt3')\">Circulo dividido</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('circleOpt1')\">Circulo por medidas</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('circleOpt2')\">Circulo dividido x medidas</button>\n            </div>\n          </div>\n          \n          <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Vista</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <button ngbDropdownItem (click)=\"funcionesMenu('mapCalor')\">Mapa de calor</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('mapPuntos')\">Mapa de puntos</button>\n            </div>\n          </div>\n          \n          <!-- <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Extras</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n            </div>\n          </div> -->\n      \n          <button type=\"button\" class=\"btn btn-success btnbuscar\"  (click)=\"botonBuscar()\">Buscar</button>\n          <button type=\"button\" class=\"btn btn-primary btnbuscar\"  (click)=\"eliminarTodo()\">Limpiar</button>\n          <button type=\"button\" #colorPicker class=\"btn btn-white btnbuscar\" cpOutputFormat=\"rgba\" [(colorPicker)]=\"color\"  cpOKButton=\"true\" [style.border-color]=\"color\" [style.background]=\"color\"> Color</button>\n      </div>\n      <div class=\"divBuscarArea\">\n          <button  #buscarArea id=\"buscarArea\" class=\"btn btn-secondary\" (click)=\"busquedaPorArea()\">Buscar en esta Area</button>\n      </div>\n    <!-- Resto -->\n    <div style=\"position: relative;\">\n        <!-- Menu lateral -->\n        <div id=\"mySidepanel\" class=\"panel panel-inverse sidepanel\" data-sortable-id=\"ui-widget-1\">\n            <div class=\"panel-heading\" style=\"border-style: solid;border-color: rgba(159, 177, 226, 0.5);background-color:rgba(79, 131, 183, 0.7) !important; color:white;\">\n                <h4 class=\"panel-title\">Menu <a href=\"javascript:void(0)\" class=\"closebtn\" (click)=\"closeNav()\">\u00D7</a></h4> \n              </div>\n            <div class=\"panel-body custom-panel\" >\n              <!-- subpanel -->\n              <input #inputDirecciones id=\"inputDirecciones\" type=\"text\" class=\"form-control input-white\" (click)=\"changeShowValue()\" (keyup.Enter)=\" busquedaPorTexto()\" [placeholder]=\"inputPlaceholder+'...'\" />  \n              <div id=\"OptionExtrasBusquedas\" *ngIf=\"showOption\">\n                <!-- begin #accordion -->\n                <!-- <div class=\"panel-heading\" style=\"background-color:rgba(79, 131, 183, 0.7) !important; color:white;\">\n                    <h4 class=\"panel-title\">Buscar en</h4> \n                  </div> -->\n                  <div class=\"panel-body caja\" style=\"background-color: white\">\n                      <div class=\"row\">\n                        <div  *ngFor=\"let busqueda of busquedasTexto\"class=\"cardCustom\">\n                          <a (click)=\"seleccionarBusqueda(busqueda.nombre)\">\n                            <img [src]=\"busqueda.icon\"\n                            class=\"card-img-top imageBusqueda\" alt=\"...\">\n                        <div class=\"card-body customBody\">\n                          {{busqueda.titulo}}\n                          <!-- <p class=\"card-text\" style=\"width: 100%\">\n                          </p> -->\n                        </div>\n                      </a>\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <button id=\"btnFiltro\" type=\"button\" (click)=\"isCollapsed = !isCollapsed\"\n              [attr.aria-expanded]=\"!isCollapsed\" aria-controls=\"collapseExample\">\n                      <i class=\"fas fa-filter fa-lg\"></i>Filtros\n                    </button>\n                    <div id=\"collapseExample\" [ngbCollapse]=\"isCollapsed\">\n                      <div class=\"card\">\n                        <div class=\"card-body caja\">\n                          <ngbi-filter [filters]=\"filtrosGlobales\"></ngbi-filter>\n                        </div>\n                      </div>\n              </div> \n              <button id=\"btnResultados\" type=\"button\" (click)=\"isCollapsedR = !isCollapsedR\"\n              [attr.aria-expanded]=\"!isCollapsedR\" aria-controls=\"collapseExampleR\">\n              Resultados\n              </button>\n              <div id=\"collapseExampleR\" [ngbCollapse]=\"isCollapsedR\">\n                <div *ngFor=\"let det of infoDetalle; let i = index\" class=\"card\" style=\"width: 100%;\">\n                    <div class=\"card-body caja\">\n                      <!-- <h5 class=\"card-title\">{{i}}</h5> -->\n                      <!-- Iterar titulo y values. -->\n                      <!-- infoDetTitulo infoDetValues -->\n                      <h4>{{infoTitulos[i]}}</h4>\n                    <p ><label class=\"labelDetalle\" *ngFor=\"let item of infoDetTitulo[i]; let o = index\"> {{infoDetTitulo[i][o]}}: {{infoDetValues[i][o]}}</label></p>\n                    \n                    <span *ngIf=\"infoDetBotones.length>0\" id=\"botonesDetalle\" class=\"input-group-btn\">\n                      <button *ngFor=\"let boton of infoDetBotones[i]\" type=\"button\" [class]=\"boton.clase\" (click)=\"clickDetExt(det,boton.accion)\" > <i *ngIf=\"boton.tipo=='icono'\" [class]=\"boton.contenido\"></i> <p *ngIf=\"boton.tipo=='text'|| boton.tipo==null || boton.tipo==undefined\">{{boton.contenido}}</p></button>\n                    </span>\n                  </div>\n                </div>\n                <div *ngIf=\"infoDetalle.length>0\" style=\"display: flex; justify-content: flex-end;\">\n                  <button class=\"btn btn-primary\" (click)=\"detallePaginaAnterior()\" >Anterior</button>\n                  <button class=\"btn btn-secundary\" (click)=\"detallePaginaSiguiente()\">Siguiente</button>\n                </div>\n              </div> \n              <!-- end subpanel -->\n              <!-- <ngbi-filter [filters]=\"filtrosGlobales\"></ngbi-filter> -->\n              <div #labelActualizar class=\"footerMenuLateral\">\n                <input type=\"checkbox\" value=\"false\" [(ngModel)]=\"chkActualizarResult\" >\n                <label style=\"padding-left: 4px;\">\n                    Actualizar al mover el mapa\n                  </label>\n                </div>\n              </div>\n        </div>\n        <div id=\"map\" (click)='cerrarPopUpV2()'>\n            <button  id=\"openbtn\" class=\"openbtn\" (click)=\"openNav()\">></button>\n            <button  id=\"openBtnMas\" class=\"openBtnMas\" (click)=\"openNavMas()\">></button>\n        </div>\n    </div>\n  </div>\n\n  <!-- Menu boton defecho -->\n  <div #menu class=\"menu\">\n    <ul class=\"menu-options\">\n      <li class=\"menu-option\"><a (click)=\"buscarEnFiguraSeleccionada()\">Buscar </a></li>\n      <li class=\"menu-option\"><a (click)=\"buscarEnFiguraResultados()\">Resultados </a></li>\n      <li class=\"menu-option\"><a (click)=\"eliminarSeleccionado()\">Eliminar </a></li>\n    </ul>\n  </div>\n  <div>\n    <div id=\"popup\" class=\"ol-popup\">\n      <div id=\"scroll\">\n        <a id=\"popup-closer\" class=\"ol-popup-closer btn-links\"></a>\n        <div id=\"popup-content\"></div>\n      </div>\n    </div>\n  </div>\n  <div id=\"mouse-position\"></div>\n\n</div>\n",
                styles: ["#map{width:100%}.componentMap{height:100%;width:100%;position:relative}#buscarArea{display:none}.footerMenuLateral{bottom:0;display:none;padding-top:11px;padding-bottom:20px}.divBuscarArea{z-index:2;position:absolute;-webkit-box-pack:center;justify-content:center;display:-webkit-box;display:flex;margin-top:1vh;width:100%}#scroll{height:37vh;width:40vw;overflow-y:scroll;overflow-x:hidden}.ol-popup{position:absolute;background-color:#fff;-webkit-filter:drop-shadow(0 1px 4px rgba(0, 0, 0, .2));filter:drop-shadow(0 1px 4px rgba(0, 0, 0, .2));padding:15px;border-radius:10px;border:1px solid #ccc;bottom:12px;left:-50px;width:44vw;height:42vh}.ol-popup:after,.ol-popup:before{top:100%;border:solid transparent;content:\" \";height:0;width:0;position:absolute;pointer-events:none}.ol-popup:after{border-top-color:#fff;border-width:10px;left:48px;margin-left:-10px}.ol-popup:before{border-top-color:#ccc;border-width:11px;left:48px;margin-left:-11px}.ol-popup-closer{text-decoration:none;position:absolute;top:2px;right:8px}.ol-popup-closer:after{content:\"\u2716\"}.centrado{margin-left:auto;margin-right:auto}.badgebox{opacity:0}.badgebox+.badge{text-indent:-999999px;width:27px}.badgebox:focus+.badge{box-shadow:inset 0 0 5px}.badgebox:checked+.badge{text-indent:0}.div-filtros{display:-webkit-box;display:flex;align-self:center;margin-right:5px}.titulo-date{color:#000;display:-webkit-box;display:flex;align-self:center}.botonMenu{background-color:#82a6ca;color:#fff}.btnbuscar{width:4rem;-webkit-box-flex:0;flex:none;margin-left:10px!important;color:#fff!important}.divMenu{background-color:#82a6ca;color:#000;width:100%}.input-filtro{width:20vw;display:inline}.switcher{display:-webkit-box;display:flex;margin-bottom:2px}.divFiltros{display:-webkit-inline-box;margin-left:10px;padding-top:6px}.custom-day{text-align:center;padding:.185rem .25rem;display:inline-block;height:2rem;width:2rem}.custom-day.focused{background-color:#e6e6e6}.custom-day.range,.custom-day:hover{background-color:#0275d8;color:#fff}.custom-day.faded{background-color:rgba(2,117,216,.5)}.itemFiltro{display:-webkit-inline-box;margin-left:10px}.show-ranges{left:315px!important}.md-drppicker{color:#000!important}.custom-panel{display:-webkit-box;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;flex-direction:column}.caja{border:1px solid;margin-bottom:5px}#inputDirecciones{width:100%;display:-webkit-box;z-index:900;background-color:rgba(255,255,255,.8);border-color:#5f9ea0}.Search{position:absolute;display:list-item;top:25vh;background:rgba(255,255,255,.5);left:1vw}.Search button{margin-left:6vw;margin-right:6vw}.Search label{margin-left:1vw}.Search input{width:50%;margin-left:1vw}.Search select{margin-top:6px;margin-left:1vw}#OptionExtrasBusquedas{z-index:1;width:100%}.imageBusqueda{border-radius:30%;height:4rem;width:5rem}.customBody{width:auto;padding:0!important;display:-webkit-box;display:flex;-webkit-box-pack:center;justify-content:center}.cardCustom{width:5rem}body{font-family:Lato,sans-serif}.sidepanel{z-index:3;height:100%;width:0;background-color:rgba(255,255,255,1);overflow-y:auto;overflow-x:hidden;-webkit-transition:.5s;transition:.5s;margin-bottom:0;position:absolute}.sidepanel input{background-color:rgba(255,255,255,.7)}.sidepanel a{text-decoration:none;font-size:14px;color:#818181;display:block;-webkit-transition:.3s;transition:.3s}.sidepanel a:hover{color:rgba(241,241,241)}.closebtn{position:absolute;top:0;right:0;font-size:36px!important;color:#fff}.openbtn{display:block;font-size:20px;cursor:pointer;background-color:rgba(79,131,183,.7);color:#fff;padding:6px 10px;border:none;position:absolute;margin-top:7rem;z-index:2;border-radius:4px}.openBtnMas{display:none;position:absolute;margin-top:7rem;margin-left:30%;font-size:20px;cursor:pointer;background-color:rgba(79,131,183,.7);color:#fff;padding:6px 10px;border:none;z-index:2;border-radius:4px}.labelDetalle{margin-bottom:.1rem!important;font-weight:100!important;display:-webkit-box;display:flex}.openBtnMas:hover,.openbtn:hover{background-color:rgba(218,218,218,.7)}.available{color:#000!important}.menu{width:120px;box-shadow:0 4px 5px 3px rgba(0,0,0,.2);position:absolute;display:none;z-index:2;background-color:rgba(255,255,255,.904)}.menu-options{list-style:none;padding:10px 0}.menu-option{font-weight:500;font-size:14px;padding:10px 40px 10px 20px;cursor:pointer}menu:hover{background:rgba(0,0,0,.2)}#btnFiltro{border:1px solid;width:100%;height:6vh;background-color:#fff;text-align:left;border-radius:.35rem}#btnFiltro:hover,#btnResultados:hover{background-color:rgba(241,241,241,.5)}#btnResultados{border-radius:.35rem;border:1px solid;width:100%;height:6vh;background-color:#fff;text-align:left}"]
            }] }
];
/** @nocollapse */
MapaComponent.ctorParameters = () => [
    { type: NgbModal },
    { type: HttpClient },
    { type: NgxSpinnerService },
    { type: NgbCalendar },
    { type: NgbDropdownConfig },
    { type: ElementRef },
    { type: Renderer2 },
    { type: NgbDateParserFormatter }
];
MapaComponent.propDecorators = {
    app: [{ type: Input, args: ['App',] }],
    urlConfiguracion: [{ type: Input, args: ['Url',] }],
    filtroInicial: [{ type: Input, args: ['filtroInicial',] }],
    filtroConcat: [{ type: Input, args: ['filtroConcat',] }],
    clicExterno: [{ type: Output }],
    menuElement: [{ type: ViewChild, args: ['menu', null,] }],
    direccionesElement: [{ type: ViewChild, args: ['inputDirecciones', null,] }],
    colorPicker: [{ type: ViewChild, args: ['colorPicker', null,] }],
    buscarArea: [{ type: ViewChild, args: ['buscarArea', null,] }],
    labelActualizar: [{ type: ViewChild, args: ['labelActualizar', null,] }],
    handleKeyboardDownEvent: [{ type: HostListener, args: ['document:keydown', ['$event'],] }],
    handleKeyboardUpEvent: [{ type: HostListener, args: ['document:keyup', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mapa/table-data/table-data.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*const COUNTRIES: any[] = [
  {
    name: 'Russia',
    flag: 'f/f3/Flag_of_Russia.svg',
    area: 17075200,
    population: 146989754
  },
  {
    name: 'France',
    flag: 'c/c3/Flag_of_France.svg',
    area: 640679,
    population: 64979548
  },
  {
    name: 'Germany',
    flag: 'b/ba/Flag_of_Germany.svg',
    area: 357114,
    population: 82114224
  },
  {
    name: 'Portugal',
    flag: '5/5c/Flag_of_Portugal.svg',
    area: 92090,
    population: 10329506
  },
  {
    name: 'Canada',
    flag: 'c/cf/Flag_of_Canada.svg',
    area: 9976140,
    population: 36624199
  },
  {
    name: 'Vietnam',
    flag: '2/21/Flag_of_Vietnam.svg',
    area: 331212,
    population: 95540800
  },
  {
    name: 'Brazil',
    flag: '0/05/Flag_of_Brazil.svg',
    area: 8515767,
    population: 209288278
  },
  {
    name: 'Mexico',
    flag: 'f/fc/Flag_of_Mexico.svg',
    area: 1964375,
    population: 129163276
  },
  {
    name: 'United States',
    flag: 'a/a4/Flag_of_the_United_States.svg',
    area: 9629091,
    population: 324459463
  },
  {
    name: 'India',
    flag: '4/41/Flag_of_India.svg',
    area: 3287263,
    population: 1324171354
  },
  {
    name: 'Indonesia',
    flag: '9/9f/Flag_of_Indonesia.svg',
    area: 1910931,
    population: 263991379
  },
  {
    name: 'Tuvalu',
    flag: '3/38/Flag_of_Tuvalu.svg',
    area: 26,
    population: 11097
  },
  {
    name: 'China',
    flag: 'f/fa/Flag_of_the_People%27s_Republic_of_China.svg',
    area: 9596960,
    population: 1409517397
  }
];*/
class TableDataPage {
    /**
     * @param {?} http
     * @param {?} activeModal
     */
    constructor(http, activeModal) {
        this.http = http;
        this.activeModal = activeModal;
        this.status = true;
        this.configuracion = {
            columnas: [
                { nombre: "nombre", propiedad: "name" },
                { nombre: "area", propiedad: "area" },
                { nombre: "Poblacion", propiedad: "population" }
            ]
        };
        this.columnas = [];
        this.datos = [];
        this.page = 1;
        this.pageSize = 10;
        this.collectionSize = 0;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.buscarDatos();
    }
    /**
     * @return {?}
     */
    get countries() {
        return this.datos
            .map((/**
         * @param {?} datos
         * @param {?} i
         * @return {?}
         */
        (datos, i) => (Object.assign({ id: i + 1 }, datos))))
            .slice((this.page - 1) * this.pageSize, (this.page - 1) * this.pageSize + this.pageSize);
    }
    /**
     * @private
     * @return {?}
     */
    buscarDatos() {
        this.datos = [];
        /** @type {?} */
        let newParams = {
            page: this.page,
            pageSize: this.pageSize
        };
        Object.assign(this.params, newParams);
        console.log("Parametros Modal>>", this.params);
        this.http.post(this.URL, this.params, { headers: new HttpHeaders({ 'Content-Type': 'application/json' }) }).subscribe((/**
         * @param {?} response
         * @return {?}
         */
        response => {
            console.log("This is the response data>>>>>>", response);
            if (response == null || response == undefined || response[0] == null || response[0] == undefined) {
                this.activeModal.close();
                console.log("Alerta", "No se encontraron datos");
                return;
            }
            this.columnas = Object.keys(response[0]);
            this.columnas.splice(this.columnas.indexOf('Exterior'), 1);
            this.columnas.splice(this.columnas.indexOf('FechaNacimiento'), 1);
            this.columnas.splice(this.columnas.indexOf('Interior'), 1);
            this.columnas.splice(this.columnas.indexOf('Sexo'), 1);
            this.columnas.splice(this.columnas.indexOf('tipoBusqueda'), 1);
            this.columnas.splice(this.columnas.indexOf('tipoConsulta'), 1);
            this.datos = response;
            this.collectionSize = this.datos.length * this.page;
            console.log("Objeto KEYS", Object.keys(response[0]));
            console.log("thisdata><", this.datos);
        }));
    }
    /**
     * @return {?}
     */
    paginaSiguiente() {
        this.page++;
        this.buscarDatos();
    }
    /**
     * @return {?}
     */
    paginaAnterior() {
        this.page--;
        this.buscarDatos();
    }
}
TableDataPage.decorators = [
    { type: Component, args: [{
                selector: 'table-data',
                template: "<table class=\"table \">\r\n  <thead>\r\n    <tr>\r\n      <th scope=\"col\">#</th>\r\n      <th *ngFor=\"let columna of columnas\" scope=\"col\">{{columna}}</th>\r\n    </tr>\r\n  </thead>\r\n  <tbody>\r\n    <tr *ngFor=\"let country of datos\">\r\n      <th scope=\"row\">{{ country.id }}</th>\r\n      <td *ngFor=\"let columna of columnas\">{{ country[columna] }}</td>\r\n    </tr>\r\n  </tbody>\r\n</table>\r\n<div>\r\n  <select class=\"custom-select\" style=\"width: auto\" [(ngModel)]=\"pageSize\">\r\n    <option [ngValue]=\"5\">5 items per page</option>\r\n    <option [ngValue]=\"10\">10 items per page</option>\r\n    <option [ngValue]=\"15\">15 items per page</option>\r\n  </select>\r\n</div>\r\n<div class=\"d-flex justify-content-between p-2\">\r\n  <div class=\"btn-group\" role=\"group\" aria-label=\"Basic example\">\r\n      <button type=\"button\" (click)=\"paginaAnterior()\" class=\"btn btn-secondary\" *ngIf=\"page>1\">Anterior</button>\r\n      <button type=\"button\" class=\"btn btn-secondary\">{{page}}</button>\r\n      <button type=\"button\" (click)=\"paginaSiguiente()\" class=\"btn btn-secondary\" *ngIf=\"datos.length>pageSize\">Siguiente</button>\r\n  </div>\r\n  <!-- <ngb-pagination [collectionSize]=\"collectionSize\" [(page)]=\"page\" [pageSize]=\"pageSize\">\r\n  </ngb-pagination> -->\r\n\r\n</div>\r\n",
                encapsulation: ViewEncapsulation.None,
                styles: [".modal-dialog{max-width:-webkit-max-content;max-width:-moz-max-content;max-width:max-content}"]
            }] }
];
/** @nocollapse */
TableDataPage.ctorParameters = () => [
    { type: HttpClient },
    { type: NgbActiveModal }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngbi-map.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgbiMapModule {
}
NgbiMapModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgbiMapComponent, MapaComponent, TableDataPage],
                imports: [
                    NgbModule,
                    FormsModule,
                    HttpClientModule,
                    NgxSpinnerModule,
                    ColorPickerModule,
                    FiltersModule,
                    NgbPaginationModule,
                    NgbAlertModule,
                    BrowserModule
                ],
                entryComponents: [
                    TableDataPage
                ],
                exports: [NgbiMapComponent, MapaComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngbi-map.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgbiMapService, NgbiMapComponent, NgbiMapModule, MapaComponent, TableDataPage as ɵa };

//# sourceMappingURL=ngbi-map.js.map