import { OnInit, ElementRef, Renderer2, EventEmitter } from '@angular/core';
import Map from 'ol/Map.js';
import GoogleLayer from 'olgm/layer/Google.js';
import { Feature, Collection } from 'ol';
import TileLayer from 'ol/layer/Tile';
import { Vector, Cluster, TileWMS } from 'ol/source';
import { Vector as VectorLayer, Heatmap } from 'ol/layer';
import { Draw, Snap } from 'ol/interaction';
import Polygon from 'ol/geom/Polygon';
import { NgbModal, NgbDropdownConfig, NgbDateParserFormatter, NgbCalendar } from '@ng-bootstrap/ng-bootstrap';
import { NgxSpinnerService } from 'ngx-spinner';
import { HttpClient } from '@angular/common/http';
import { Observable, Subject } from 'rxjs';
import { Filter } from 'ngbi-filters';
export declare class MapaComponent implements OnInit {
    private modalService;
    private http;
    private spinner;
    calendar: NgbCalendar;
    private renderer;
    private _parserFormatter;
    app: any;
    urlConfiguracion: any;
    filtroInicial: any;
    filtroConcat: any;
    clicExterno: EventEmitter<{}>;
    menuElement: ElementRef;
    direccionesElement: ElementRef;
    colorPicker: ElementRef;
    buscarArea: ElementRef;
    labelActualizar: ElementRef;
    map: Map;
    source: Vector;
    MyVectorSource: Vector;
    selectedFeatures: Collection<Feature>;
    snap: Snap;
    draw: Draw;
    view: any;
    clusterSource: Cluster;
    clusterLayer: VectorLayer;
    googleLayer: GoogleLayer;
    OSMLayer: TileLayer;
    content: HTMLElement;
    container: HTMLElement;
    closer: HTMLElement;
    overlay: any;
    utilizandoPopUp: boolean;
    texto: string;
    coordenadasActual: any[];
    totalEncontrados: number;
    tipoSeleccionado: string;
    infoBusquedas: Array<any>;
    busquedasActuales: Array<any>;
    clusterAnimado: any;
    Intersecciones: any[];
    modoInterseccion: boolean;
    modoDiferencia: boolean;
    modoInterseccionAutomatica: boolean;
    tipoCirculo: number;
    selectCluster: any;
    habilitarDireccion: boolean;
    hole: {};
    olGM: any;
    center: Array<number>;
    color: string;
    zoom: number;
    mapaPredeterminado: string;
    capasActuales: any[];
    procesandoFeature: boolean;
    filtrosGlobales: Array<Filter>;
    showOption: boolean;
    busquedasTexto: Array<any>;
    busquedaTextoActual: any;
    teclaPresionada: string;
    featuresSeleccionados: any[];
    inputPlaceholder: string;
    viewChanged: Subject<any>;
    viewSubcription: any;
    isCollapsed: boolean;
    isCollapsedR: boolean;
    busquedaFacetLayer: any;
    busquedaTextoLayer: any;
    busquedaClusterLayer: any;
    figurasActivas: any[];
    tiposOrigenes: any[];
    busquedasActuales2: any[];
    busquedaTextuales: any[];
    paginacionGeo: {
        pagActual: number;
        RPP: number;
        geometrysWKT: any;
        tipoOrigen: any;
        UUID: any;
    };
    infoDetalle: any[];
    infoVista: any[];
    infoDetTitulo: any[];
    infoDetValues: any[];
    busquedaAnterior: any[];
    confBusquedaGeo: any;
    confBusquedaText: any;
    confInicializacion: any;
    confCapas: any;
    featureAnteriorDireccion: any;
    mapaCalor: Heatmap;
    statusMapaCalor: boolean;
    chkActualizarResult: boolean;
    confResultadosVista: any;
    buscando: Boolean;
    infoTitulos: any[];
    infoDetBotones: any[];
    handleKeyboardDownEvent(event: KeyboardEvent): void;
    handleKeyboardUpEvent(event: KeyboardEvent): void;
    constructor(modalService: NgbModal, http: HttpClient, spinner: NgxSpinnerService, calendar: NgbCalendar, config: NgbDropdownConfig, element: ElementRef, renderer: Renderer2, _parserFormatter: NgbDateParserFormatter);
    ngOnInit(): void;
    generarFiguraVentana(): void;
    inicializarVariables(): void;
    inicializarMapa(): void;
    inicializarEventos(): void;
    crearLayersBusqueda(): void;
    crearEstilo(index: any, iconos: any): (feature: any) => any;
    generarSource(configSource: any): Cluster | TileWMS;
    generarLayer(configLayer: any, source: any): any;
    createIntersectionYDiferenciaAutomatica(features: Array<Feature>): Promise<{}>;
    createIntersection(features: Array<Feature>): void;
    insertarFeatureJSTS(parser: any, featureJSTS: any, source?: any, _style?: any): Promise<{}>;
    createDiference(features: Array<Feature>): void;
    convertJSTSGeometryPolygonToOL3Polygon(a: any): Polygon;
    eventoClick(map: any, This: any, container: any, overlay: any): void;
    busquedaGeo(Coordenadas: any, Tipo: any, Distance: any, extent: any): void;
    selectedOn(selectedFeatures: any, This: any): void;
    drawOnEvent(draw: any, source: any, map: any, overlay: any, content: any, selectedFeatures: any, THIS: any, hole: any): void;
    addDraw(tipoDibujo: any): void;
    cerrarPopup(clos: any, Selecteddfeatures: any, overlay: any, THIS: any): void;
    cerrarPopUpV2(): void;
    UTCaLocal(stringUTC: string): Date;
    eventDoubleClick(map: any, selectedFeatures: any): void;
    desactivarZoomDobleClick(map: any): void;
    ajustarZoom(clusterSource: any): void;
    obtenerFechaFormateada(fecha: any, tipo: any): string;
    funcionesMenu(obj: any): void;
    eliminarTodo(): void;
    eliminarSeleccionado(): void;
    cursorCruz(): void;
    cursorOriginal(): void;
    botonBuscar(): boolean;
    cambiarMapaCalor(status: Boolean): void;
    calcularPuntoMedio(p1: Array<number>, p2: Array<number>): any[];
    buscarEnFiguraSeleccionada(): void;
    InitBusquedaGM(boolOnOff: any, input: any, map: any, This?: this): void;
    llenarPopUp(header: any, feature: any, This?: this): void;
    seleccionarBusqueda(fuente: any): void;
    busquedaPorTexto(): void;
    resultadoPorBusquedaTextoAsync(nombre: any, dataResponse: any): void;
    openNav(): void;
    openNavMas(): void;
    closeNav(): void;
    ocultarClickDerechoMenu(): void;
    clickDerechoMenu(): void;
    InicializarEventoViewChange(This: any): void;
    consultarV2(): Promise<{}>;
    agregarFeatureExperimental(data: any, layer: any, tipo: any): void;
    cambiarStatusBusqueda(titulo: any): void;
    buscarDetalle(): void;
    detallePaginaSiguiente(): void;
    detallePaginaAnterior(): void;
    buscarEnFiguraResultados(): void;
    obtenerConfiguracion(): Observable<Object>;
    busquedaInicial(): void;
    busquedaPorArea(): void;
    vaciarCajaResultados(): void;
    clickDetExt(modelo: any, accion: any): void;
    changeShowValue(): void;
}
